/*!
  * =============================================================
  * Ender: open module JavaScript framework (https://ender.no.de)
  * Build: ender build jeesh ahr2 futures toDataURL
  * =============================================================
  */

/*!
  * Ender: open module JavaScript framework (client-lib)
  * copyright Dustin Diaz & Jacob Thornton 2011 (@ded @fat)
  * http://ender.no.de
  * License MIT
  */
!function (context) {

  // a global object for node.js module compatiblity
  // ============================================

  context['global'] = context

  // Implements simple module system
  // losely based on CommonJS Modules spec v1.1.1
  // ============================================

  var modules = {}
    , old = context.$

  function require (identifier) {
    // modules can be required from ender's build system, or found on the window
    var module = modules[identifier] || window[identifier]
    if (!module) throw new Error("Requested module '" + identifier + "' has not been defined.")
    return module
  }

  function provide (name, what) {
    return (modules[name] = what)
  }

  context['provide'] = provide
  context['require'] = require

  function aug(o, o2) {
    for (var k in o2) k != 'noConflict' && k != '_VERSION' && (o[k] = o2[k])
    return o
  }

  function boosh(s, r, els) {
    // string || node || nodelist || window
    if (typeof s == 'string' || s.nodeName || (s.length && 'item' in s) || s == window) {
      els = ender._select(s, r)
      els.selector = s
    } else els = isFinite(s.length) ? s : [s]
    return aug(els, boosh)
  }

  function ender(s, r) {
    return boosh(s, r)
  }

  aug(ender, {
      _VERSION: '0.3.6'
    , fn: boosh // for easy compat to jQuery plugins
    , ender: function (o, chain) {
        aug(chain ? boosh : ender, o)
      }
    , _select: function (s, r) {
        return (r || document).querySelectorAll(s)
      }
  })

  aug(boosh, {
    forEach: function (fn, scope, i) {
      // opt out of native forEach so we can intentionally call our own scope
      // defaulting to the current item and be able to return self
      for (i = 0, l = this.length; i < l; ++i) i in this && fn.call(scope || this[i], this[i], i, this)
      // return self for chaining
      return this
    },
    $: ender // handy reference to self
  })

  ender.noConflict = function () {
    context.$ = old
    return this
  }

  if (typeof module !== 'undefined' && module.exports) module.exports = ender
  // use subscript notation as extern for Closure compilation
  context['ender'] = context['$'] = context['ender'] || ender

}(this);

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function (exports) {
      'use strict';
  
      var lookup = [
          'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
          'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
          'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
          'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
          'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
          'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
          'w', 'x', 'y', 'z', '0', '1', '2', '3',
          '4', '5', '6', '7', '8', '9', '+', '/'
      ];
  
      function uint8ToBase64(uint8) {
          var i,
              extraBytes = uint8.length % 3, // if we have 1 byte left, pad 2 bytes
              output = "",
              temp, length;
  
          function tripletToBase64 (num) {
              return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F];
          };
  
          // go through the array every three bytes, we'll deal with trailing stuff later
          for (i = 0, length = uint8.length - extraBytes; i < length; i += 3) {
              temp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2]);
              output += tripletToBase64(temp);
          }
  
          // this prevents an ERR_INVALID_URL in Chrome (Firefox okay)
          switch (output.length % 4) {
              case 1:
                  output += '=';
                  break;
              case 2:
                  output += '==';
                  break;
              default:
              break;
          }
  
          return output;
      }
  
      function openDataURL(dataURI, name) {
          window.open(dataURI, name || '_self');
      }
  
      function createDataURL (data, mimeType, autoDownload) {
          var tmp, base64, dataURI, i;
  
          if (!data || (typeof data !== 'string' && !(data instanceof Array) && !(data instanceof Uint8Array))) {
              throw 'Data must be a non-empty string, Array, or Uint8Array';
          }
  
          if (typeof mimeType !== 'string') {
              autoDownload = mimeType;
              mimeType = 'application/octet-stream';
          }
          if (typeof autoDownload !== 'boolean') {
              autoDownload = false;
          }
  
          if (typeof data === 'string') {
              tmp = encodeURIComponent(data);
              tmp = unescape(tmp || data.toString());
              base64 = btoa(tmp);
          } else if (data instanceof Array) {
              tmp = new Uint8Array(data.length);
              for (i = data.length; i >= 0; i -= 1) {
                  tmp[i] = data[i] & 0xFF;
              }
              base64 = uint8ToBase64(tmp);
          } else if (data instanceof Uint8Array) {
              base64 = uint8ToBase64(data);
          }
  
          dataURI = 'data:' + mimeType + ';base64,' + base64;
  
          if (autoDownload) {
              openDataURL(dataURI);
          }
  
          return dataURI;
      }
  
      exports.toDataURL = createDataURL;
      exports.openDataURL = openDataURL;
  }(typeof module !== 'undefined' ? module.exports : window));
  

  provide("toDataURL", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*!
    * bean.js - copyright Jacob Thornton 2011
    * https://github.com/fat/bean
    * MIT License
    * special thanks to:
    * dean edwards: http://dean.edwards.name/
    * dperini: https://github.com/dperini/nwevents
    * the entire mootools team: github.com/mootools/mootools-core
    */
  !function (name, definition) {
    if (typeof module != 'undefined') module.exports = definition();
    else if (typeof define == 'function' && typeof define.amd  == 'object') define(definition);
    else this[name] = definition();
  }('bean', function () {
    var win = window,
        __uid = 1,
        registry = {},
        collected = {},
        overOut = /over|out/,
        namespace = /[^\.]*(?=\..*)\.|.*/,
        stripName = /\..*/,
        addEvent = 'addEventListener',
        attachEvent = 'attachEvent',
        removeEvent = 'removeEventListener',
        detachEvent = 'detachEvent',
        doc = document || {},
        root = doc.documentElement || {},
        W3C_MODEL = root[addEvent],
        eventSupport = W3C_MODEL ? addEvent : attachEvent,
  
    isDescendant = function (parent, child) {
      var node = child.parentNode;
      while (node !== null) {
        if (node == parent) {
          return true;
        }
        node = node.parentNode;
      }
    },
  
    retrieveUid = function (obj, uid) {
      return (obj.__uid = uid && (uid + '::' + __uid++) || obj.__uid || __uid++);
    },
  
    retrieveEvents = function (element) {
      var uid = retrieveUid(element);
      return (registry[uid] = registry[uid] || {});
    },
  
    listener = W3C_MODEL ? function (element, type, fn, add) {
      element[add ? addEvent : removeEvent](type, fn, false);
    } : function (element, type, fn, add, custom) {
      if (custom && add && element['_on' + custom] === null) {
        element['_on' + custom] = 0;
      }
      element[add ? attachEvent : detachEvent]('on' + type, fn);
    },
  
    nativeHandler = function (element, fn, args) {
      return function (event) {
        event = fixEvent(event || ((this.ownerDocument || this.document || this).parentWindow || win).event);
        return fn.apply(element, [event].concat(args));
      };
    },
  
    customHandler = function (element, fn, type, condition, args) {
      return function (event) {
        if (condition ? condition.apply(this, arguments) : W3C_MODEL ? true : event && event.propertyName == '_on' + type || !event) {
          event = event ? fixEvent(event || ((this.ownerDocument || this.document || this).parentWindow || win).event) : null;
          fn.apply(element, Array.prototype.slice.call(arguments, event ? 0 : 1).concat(args));
        }
      };
    },
  
    addListener = function (element, orgType, fn, args) {
      var type = orgType.replace(stripName, ''),
          events = retrieveEvents(element),
          handlers = events[type] || (events[type] = {}),
          originalFn = fn,
          uid = retrieveUid(fn, orgType.replace(namespace, ''));
      if (handlers[uid]) {
        return element;
      }
      var custom = customEvents[type];
      if (custom) {
        fn = custom.condition ? customHandler(element, fn, type, custom.condition) : fn;
        type = custom.base || type;
      }
      var isNative = nativeEvents[type];
      fn = isNative ? nativeHandler(element, fn, args) : customHandler(element, fn, type, false, args);
      isNative = W3C_MODEL || isNative;
      if (type == 'unload') {
        var org = fn;
        fn = function () {
          removeListener(element, type, fn) && org();
        };
      }
      element[eventSupport] && listener(element, isNative ? type : 'propertychange', fn, true, !isNative && type);
      handlers[uid] = fn;
      fn.__uid = uid;
      fn.__originalFn = originalFn;
      return type == 'unload' ? element : (collected[retrieveUid(element)] = element);
    },
  
    removeListener = function (element, orgType, handler) {
      var uid, names, uids, i, events = retrieveEvents(element), type = orgType.replace(stripName, '');
      if (!events || !events[type]) {
        return element;
      }
      names = orgType.replace(namespace, '');
      uids = names ? names.split('.') : [handler.__uid];
  
      function destroyHandler(uid) {
        handler = events[type][uid];
        if (!handler) {
          return;
        }
        delete events[type][uid];
        if (element[eventSupport]) {
          type = customEvents[type] ? customEvents[type].base : type;
          var isNative = W3C_MODEL || nativeEvents[type];
          listener(element, isNative ? type : 'propertychange', handler, false, !isNative && type);
        }
      }
  
      destroyHandler(names); //get combos
      for (i = uids.length; i--; destroyHandler(uids[i])) {} //get singles
  
      return element;
    },
  
    del = function (selector, fn, $) {
      return function (e) {
        var array = typeof selector == 'string' ? $(selector, this) : selector;
        for (var target = e.target; target && target != this; target = target.parentNode) {
          for (var i = array.length; i--;) {
            if (array[i] == target) {
              return fn.apply(target, arguments);
            }
          }
        }
      };
    },
  
    add = function (element, events, fn, delfn, $) {
      if (typeof events == 'object' && !fn) {
        for (var type in events) {
          events.hasOwnProperty(type) && add(element, type, events[type]);
        }
      } else {
        var isDel = typeof fn == 'string', types = (isDel ? fn : events).split(' ');
        fn = isDel ? del(events, delfn, $) : fn;
        for (var i = types.length; i--;) {
          addListener(element, types[i], fn, Array.prototype.slice.call(arguments, isDel ? 4 : 3));
        }
      }
      return element;
    },
  
    remove = function (element, orgEvents, fn) {
      var k, m, type, events, i,
          isString = typeof(orgEvents) == 'string',
          names = isString && orgEvents.replace(namespace, ''),
          rm = removeListener,
          attached = retrieveEvents(element);
      names = names && names.split('.');
      if (isString && /\s/.test(orgEvents)) {
        orgEvents = orgEvents.split(' ');
        i = orgEvents.length - 1;
        while (remove(element, orgEvents[i]) && i--) {}
        return element;
      }
      events = isString ? orgEvents.replace(stripName, '') : orgEvents;
      if (!attached || names || (isString && !attached[events])) {
        for (k in attached) {
          if (attached.hasOwnProperty(k)) {
            for (i in attached[k]) {
              for (m = names.length; m--;) {
                attached[k].hasOwnProperty(i) && new RegExp('^' + names[m] + '::\\d*(\\..*)?$').test(i) && rm(element, [k, i].join('.'));
              }
            }
          }
        }
        return element;
      }
      if (typeof fn == 'function') {
        rm(element, events, fn);
      } else if (names) {
        rm(element, orgEvents);
      } else {
        rm = events ? rm : remove;
        type = isString && events;
        events = events ? (fn || attached[events] || events) : attached;
        for (k in events) {
          if (events.hasOwnProperty(k)) {
            rm(element, type || k, events[k]);
            delete events[k]; // remove unused leaf keys
          }
        }
      }
      return element;
    },
  
    fire = function (element, type, args) {
      var evt, k, i, m, types = type.split(' ');
      for (i = types.length; i--;) {
        type = types[i].replace(stripName, '');
        var isNative = nativeEvents[type],
            isNamespace = types[i].replace(namespace, ''),
            handlers = retrieveEvents(element)[type];
        if (isNamespace) {
          isNamespace = isNamespace.split('.');
          for (k = isNamespace.length; k--;) {
            for (m in handlers) {
              handlers.hasOwnProperty(m) && new RegExp('^' + isNamespace[k] + '::\\d*(\\..*)?$').test(m) && handlers[m].apply(element, [false].concat(args));
            }
          }
        } else if (!args && element[eventSupport]) {
          fireListener(isNative, type, element);
        } else {
          for (k in handlers) {
            handlers.hasOwnProperty(k) && handlers[k].apply(element, [false].concat(args));
          }
        }
      }
      return element;
    },
  
    fireListener = W3C_MODEL ? function (isNative, type, element) {
      evt = document.createEvent(isNative ? "HTMLEvents" : "UIEvents");
      evt[isNative ? 'initEvent' : 'initUIEvent'](type, true, true, win, 1);
      element.dispatchEvent(evt);
    } : function (isNative, type, element) {
      isNative ? element.fireEvent('on' + type, document.createEventObject()) : element['_on' + type]++;
    },
  
    clone = function (element, from, type) {
      var events = retrieveEvents(from), obj, k;
      var uid = retrieveUid(element);
      obj = type ? events[type] : events;
      for (k in obj) {
        obj.hasOwnProperty(k) && (type ? add : clone)(element, type || from, type ? obj[k].__originalFn : k);
      }
      return element;
    },
  
    fixEvent = function (e) {
      var result = {};
      if (!e) {
        return result;
      }
      var type = e.type, target = e.target || e.srcElement;
      result.preventDefault = fixEvent.preventDefault(e);
      result.stopPropagation = fixEvent.stopPropagation(e);
      result.target = target && target.nodeType == 3 ? target.parentNode : target;
      if (~type.indexOf('key')) {
        result.keyCode = e.which || e.keyCode;
      } else if ((/click|mouse|menu/i).test(type)) {
        result.rightClick = e.which == 3 || e.button == 2;
        result.pos = { x: 0, y: 0 };
        if (e.pageX || e.pageY) {
          result.clientX = e.pageX;
          result.clientY = e.pageY;
        } else if (e.clientX || e.clientY) {
          result.clientX = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
          result.clientY = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
        }
        overOut.test(type) && (result.relatedTarget = e.relatedTarget || e[(type == 'mouseover' ? 'from' : 'to') + 'Element']);
      }
      for (var k in e) {
        if (!(k in result)) {
          result[k] = e[k];
        }
      }
      return result;
    };
  
    fixEvent.preventDefault = function (e) {
      return function () {
        if (e.preventDefault) {
          e.preventDefault();
        }
        else {
          e.returnValue = false;
        }
      };
    };
  
    fixEvent.stopPropagation = function (e) {
      return function () {
        if (e.stopPropagation) {
          e.stopPropagation();
        } else {
          e.cancelBubble = true;
        }
      };
    };
  
    var nativeEvents = { click: 1, dblclick: 1, mouseup: 1, mousedown: 1, contextmenu: 1, //mouse buttons
      mousewheel: 1, DOMMouseScroll: 1, //mouse wheel
      mouseover: 1, mouseout: 1, mousemove: 1, selectstart: 1, selectend: 1, //mouse movement
      keydown: 1, keypress: 1, keyup: 1, //keyboard
      orientationchange: 1, // mobile
      touchstart: 1, touchmove: 1, touchend: 1, touchcancel: 1, // touch
      gesturestart: 1, gesturechange: 1, gestureend: 1, // gesture
      focus: 1, blur: 1, change: 1, reset: 1, select: 1, submit: 1, //form elements
      load: 1, unload: 1, beforeunload: 1, resize: 1, move: 1, DOMContentLoaded: 1, readystatechange: 1, //window
      error: 1, abort: 1, scroll: 1 }; //misc
  
    function check(event) {
      var related = event.relatedTarget;
      if (!related) {
        return related === null;
      }
      return (related != this && related.prefix != 'xul' && !/document/.test(this.toString()) && !isDescendant(this, related));
    }
  
    var customEvents = {
      mouseenter: { base: 'mouseover', condition: check },
      mouseleave: { base: 'mouseout', condition: check },
      mousewheel: { base: /Firefox/.test(navigator.userAgent) ? 'DOMMouseScroll' : 'mousewheel' }
    };
  
    var bean = { add: add, remove: remove, clone: clone, fire: fire };
  
    var clean = function (el) {
      var uid = remove(el).__uid;
      if (uid) {
        delete collected[uid];
        delete registry[uid];
      }
    };
  
    if (win[attachEvent]) {
      add(win, 'unload', function () {
        for (var k in collected) {
          collected.hasOwnProperty(k) && clean(collected[k]);
        }
        win.CollectGarbage && CollectGarbage();
      });
    }
  
    bean.noConflict = function () {
      context.bean = old;
      return this;
    };
  
    return bean;
  });

  provide("bean", module.exports);

  !function ($) {
    var b = require('bean'),
        integrate = function (method, type, method2) {
          var _args = type ? [type] : [];
          return function () {
            for (var args, i = 0, l = this.length; i < l; i++) {
              args = [this[i]].concat(_args, Array.prototype.slice.call(arguments, 0));
              args.length == 4 && args.push($);
              !arguments.length && method == 'add' && type && (method = 'fire');
              b[method].apply(this, args);
            }
            return this;
          };
        };
  
    var add = integrate('add'),
        remove = integrate('remove'),
        fire = integrate('fire');
  
    var methods = {
  
      on: add,
      addListener: add,
      bind: add,
      listen: add,
      delegate: add,
  
      unbind: remove,
      unlisten: remove,
      removeListener: remove,
      undelegate: remove,
  
      emit: fire,
      trigger: fire,
  
      cloneEvents: integrate('clone'),
  
      hover: function (enter, leave, i) { // i for internal
        for (i = this.length; i--;) {
          b.add.call(this, this[i], 'mouseenter', enter);
          b.add.call(this, this[i], 'mouseleave', leave);
        }
        return this;
      }
    };
  
    var i, shortcuts = [
      'blur', 'change', 'click', 'dblclick', 'error', 'focus', 'focusin',
      'focusout', 'keydown', 'keypress', 'keyup', 'load', 'mousedown',
      'mouseenter', 'mouseleave', 'mouseout', 'mouseover', 'mouseup', 'mousemove',
      'resize', 'scroll', 'select', 'submit', 'unload'
    ];
  
    for (i = shortcuts.length; i--;) {
      methods[shortcuts[i]] = integrate('add', shortcuts[i]);
    }
  
    $.ender(methods, true);
  }(ender);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*!
    * Bonzo: DOM Utility (c) Dustin Diaz 2011
    * https://github.com/ded/bonzo
    * License MIT
    */
  !function (name, definition) {
    if (typeof module != 'undefined') module.exports = definition()
    else if (typeof define == 'function' && define.amd) define(name, definition)
    else this[name] = definition()
  }('bonzo', function() {
    var context = this
      , old = context.bonzo
      , win = window
      , doc = win.document
      , html = doc.documentElement
      , parentNode = 'parentNode'
      , query = null
      , specialAttributes = /^checked|value|selected$/
      , specialTags = /select|fieldset|table|tbody|tfoot|td|tr|colgroup/i
      , table = [ '<table>', '</table>', 1 ]
      , td = [ '<table><tbody><tr>', '</tr></tbody></table>', 3 ]
      , option = [ '<select>', '</select>', 1 ]
      , tagMap = {
          thead: table, tbody: table, tfoot: table, colgroup: table, caption: table
          , tr: [ '<table><tbody>', '</tbody></table>', 2 ]
          , th: td , td: td
          , col: [ '<table><colgroup>', '</colgroup></table>', 2 ]
          , fieldset: [ '<form>', '</form>', 1 ]
          , legend: [ '<form><fieldset>', '</fieldset></form>', 2 ]
          , option: option
          , optgroup: option }
      , stateAttributes = /^checked|selected$/
      , ie = /msie/i.test(navigator.userAgent)
      , uidList = []
      , uuids = 0
      , digit = /^-?[\d\.]+$/
      , dattr = /^data-(.+)$/
      , px = 'px'
      , setAttribute = 'setAttribute'
      , getAttribute = 'getAttribute'
      , byTag = 'getElementsByTagName'
      , features = function() {
          var e = doc.createElement('p')
          e.innerHTML = '<a href="#x">x</a><table style="float:left;"></table>'
          return {
            hrefExtended: e[byTag]('a')[0][getAttribute]('href') != '#x' // IE < 8
            , autoTbody: e[byTag]('tbody').length !== 0 // IE < 8
            , computedStyle: doc.defaultView && doc.defaultView.getComputedStyle
            , cssFloat: e[byTag]('table')[0].style.styleFloat ? 'styleFloat' : 'cssFloat'
            , transform: function () {
                var props = ['webkitTransform', 'MozTransform', 'OTransform', 'msTransform', 'Transform'], i
                for (i = 0; i < props.length; i++) {
                  if (props[i] in e.style) return props[i]
                }
              }()
          }
        }()
      , trimReplace = /(^\s*|\s*$)/g
      , unitless = { lineHeight: 1, zoom: 1, zIndex: 1, opacity: 1 }
      , trim = String.prototype.trim ?
          function (s) {
            return s.trim()
          } :
          function (s) {
            return s.replace(trimReplace, '')
          }
  
    function classReg(c) {
      return new RegExp("(^|\\s+)" + c + "(\\s+|$)")
    }
  
    function each(ar, fn, scope) {
      for (var i = 0, l = ar.length; i < l; i++) fn.call(scope || ar[i], ar[i], i, ar)
      return ar
    }
  
    function camelize(s) {
      return s.replace(/-(.)/g, function (m, m1) {
        return m1.toUpperCase()
      })
    }
  
    function decamelize(s) {
      return s ? s.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase() : s
    }
  
    function data(el) {
      el[getAttribute]('data-node-uid') || el[setAttribute]('data-node-uid', ++uuids)
      uid = el[getAttribute]('data-node-uid')
      return uidList[uid] || (uidList[uid] = {})
    }
  
    function dataValue(d) {
      try {
        return d === 'true' ? true : d === 'false' ? false : d === 'null' ? null : !isNaN(d) ? parseFloat(d) : d;
      } catch(e) {}
      return undefined
    }
  
    function isNode(node) {
      return node && node.nodeName && node.nodeType == 1
    }
  
    function some(ar, fn, scope, i) {
      for (i = 0, j = ar.length; i < j; ++i) if (fn.call(scope, ar[i], i, ar)) return true
      return false
    }
  
    function styleProperty(p) {
        (p == 'transform' && (p = features.transform)) ||
          (/^transform-?[Oo]rigin$/.test(p) && (p = features.transform + "Origin")) ||
          (p == 'float' && (p = features.cssFloat))
        return p ? camelize(p) : null
    }
  
    var getStyle = features.computedStyle ?
      function (el, property) {
        var value = null
          , computed = doc.defaultView.getComputedStyle(el, '')
        computed && (value = computed[property])
        return el.style[property] || value
      } :
  
      (ie && html.currentStyle) ?
  
      function (el, property) {
        if (property == 'opacity') {
          var val = 100
          try {
            val = el.filters['DXImageTransform.Microsoft.Alpha'].opacity
          } catch (e1) {
            try {
              val = el.filters('alpha').opacity
            } catch (e2) {}
          }
          return val / 100
        }
        var value = el.currentStyle ? el.currentStyle[property] : null
        return el.style[property] || value
      } :
  
      function (el, property) {
        return el.style[property]
      }
  
    // this insert method is intense
    function insert(target, host, fn) {
      var i = 0, self = host || this, r = []
        // target nodes could be a css selector if it's a string and a selector engine is present
        // otherwise, just use target
        , nodes = query && typeof target == 'string' && target.charAt(0) != '<' ? query(target) : target
      // normalize each node in case it's still a string and we need to create nodes on the fly
      each(normalize(nodes), function (t) {
        each(self, function (el) {
          var n = !el[parentNode] || (el[parentNode] && !el[parentNode][parentNode]) ?
            function () {
              var c = el.cloneNode(true)
              // check for existence of an event cloner
              // preferably https://github.com/fat/bean
              // otherwise Bonzo won't do this for you
              self.$ && self.cloneEvents && self.$(c).cloneEvents(el)
              return c
            }() : el
          fn(t, n)
          r[i] = n
          i++
        })
      }, this)
      each(r, function (e, i) {
        self[i] = e
      })
      self.length = i
      return self
    }
  
    function xy(el, x, y) {
      var $el = bonzo(el)
        , style = $el.css('position')
        , offset = $el.offset()
        , rel = 'relative'
        , isRel = style == rel
        , delta = [parseInt($el.css('left'), 10), parseInt($el.css('top'), 10)]
  
      if (style == 'static') {
        $el.css('position', rel)
        style = rel
      }
  
      isNaN(delta[0]) && (delta[0] = isRel ? 0 : el.offsetLeft)
      isNaN(delta[1]) && (delta[1] = isRel ? 0 : el.offsetTop)
  
      x != null && (el.style.left = x - offset.left + delta[0] + px)
      y != null && (el.style.top = y - offset.top + delta[1] + px)
  
    }
  
    function hasClass(el, c) {
      return classReg(c).test(el.className)
    }
    function addClass(el, c) {
      el.className = trim(el.className + ' ' + c)
    }
    function removeClass(el, c) {
      el.className = trim(el.className.replace(classReg(c), ' '))
    }
  
    // this allows method calling for setting values
    // example:
  
    // bonzo(elements).css('color', function (el) {
    //   return el.getAttribute('data-original-color')
    // })
  
    function setter(el, v) {
      return typeof v == 'function' ? v(el) : v
    }
  
    function Bonzo(elements) {
      this.length = 0
      if (elements) {
        elements = typeof elements !== 'string' &&
          !elements.nodeType &&
          typeof elements.length !== 'undefined' ?
            elements :
            [elements]
        this.length = elements.length
        for (var i = 0; i < elements.length; i++) {
          this[i] = elements[i]
        }
      }
    }
  
    Bonzo.prototype = {
  
        get: function (index) {
          return this[index]
        }
  
      , each: function (fn, scope) {
          return each(this, fn, scope)
        }
  
      , map: function (fn, reject) {
          var m = [], n, i
          for (i = 0; i < this.length; i++) {
            n = fn.call(this, this[i], i)
            reject ? (reject(n) && m.push(n)) : m.push(n)
          }
          return m
        }
  
      , first: function () {
          return bonzo(this.length ? this[0] : [])
        }
  
      , last: function () {
          return bonzo(this.length ? this[this.length - 1] : [])
        }
  
      , html: function (h, text) {
          var method = text ?
            html.textContent === undefined ?
              'innerText' :
              'textContent' :
            'innerHTML', m;
          function append(el) {
            while (el.firstChild) el.removeChild(el.firstChild)
            each(normalize(h), function (node) {
              el.appendChild(node)
            })
          }
          return typeof h !== 'undefined' ?
              this.each(function (el) {
                !text && (m = el.tagName.match(specialTags)) ?
                  append(el, m[0]) :
                  (el[method] = h)
              }) :
            this[0] ? this[0][method] : ''
        }
  
      , text: function (text) {
          return this.html(text, 1)
        }
  
      , addClass: function (c) {
          return this.each(function (el) {
            hasClass(el, setter(el, c)) || addClass(el, setter(el, c))
          })
        }
  
      , removeClass: function (c) {
          return this.each(function (el) {
            hasClass(el, setter(el, c)) && removeClass(el, setter(el, c))
          })
        }
  
      , hasClass: function (c) {
          return some(this, function (el) {
            return hasClass(el, c)
          })
        }
  
      , toggleClass: function (c, condition) {
          return this.each(function (el) {
            typeof condition !== 'undefined' ?
              condition ? addClass(el, c) : removeClass(el, c) :
              hasClass(el, c) ? removeClass(el, c) : addClass(el, c)
          })
        }
  
      , show: function (type) {
          return this.each(function (el) {
            el.style.display = type || ''
          })
        }
  
      , hide: function () {
          return this.each(function (el) {
            el.style.display = 'none'
          })
        }
  
      , append: function (node) {
          return this.each(function (el) {
            each(normalize(node), function (i) {
              el.appendChild(i)
            })
          })
        }
  
      , prepend: function (node) {
          return this.each(function (el) {
            var first = el.firstChild
            each(normalize(node), function (i) {
              el.insertBefore(i, first)
            })
          })
        }
  
      , appendTo: function (target, host) {
          return insert.call(this, target, host, function (t, el) {
            t.appendChild(el)
          })
        }
  
      , prependTo: function (target, host) {
          return insert.call(this, target, host, function (t, el) {
            t.insertBefore(el, t.firstChild)
          })
        }
  
      , next: function () {
          return this.related('nextSibling')
        }
  
      , previous: function () {
          return this.related('previousSibling')
        }
  
      , related: function (method) {
          return this.map(
            function (el) {
              el = el[method]
              while (el && el.nodeType !== 1) {
                el = el[method]
              }
              return el || 0
            },
            function (el) {
              return el
            }
          )
        }
  
      , before: function (node) {
          return this.each(function (el) {
            each(bonzo.create(node), function (i) {
              el[parentNode].insertBefore(i, el)
            })
          })
        }
  
      , after: function (node) {
          return this.each(function (el) {
            each(bonzo.create(node), function (i) {
              el[parentNode].insertBefore(i, el.nextSibling)
            })
          })
        }
  
      , insertBefore: function (target, host) {
          return insert.call(this, target, host, function (t, el) {
            t[parentNode].insertBefore(el, t)
          })
        }
  
      , insertAfter: function (target, host) {
          return insert.call(this, target, host, function (t, el) {
            var sibling = t.nextSibling
            if (sibling) {
              t[parentNode].insertBefore(el, sibling);
            }
            else {
              t[parentNode].appendChild(el)
            }
          })
        }
  
      , replaceWith: function(html) {
          return this.each(function (el) {
            el.parentNode.replaceChild(bonzo.create(html)[0], el)
          })
        }
  
      , css: function (o, v, p) {
          // is this a request for just getting a style?
          if (v === undefined && typeof o == 'string') {
            // repurpose 'v'
            v = this[0]
            if (!v) {
              return null
            }
            if (v === doc || v === win) {
              p = (v === doc) ? bonzo.doc() : bonzo.viewport()
              return o == 'width' ? p.width : o == 'height' ? p.height : ''
            }
            return (o = styleProperty(o)) ? getStyle(v, o) : null
          }
          var iter = o
          if (typeof o == 'string') {
            iter = {}
            iter[o] = v
          }
  
          if (ie && iter.opacity) {
            // oh this 'ol gamut
            iter.filter = 'alpha(opacity=' + (iter.opacity * 100) + ')'
            // give it layout
            iter.zoom = o.zoom || 1;
            delete iter.opacity;
          }
  
          function fn(el, p, v) {
            for (var k in iter) {
              if (iter.hasOwnProperty(k)) {
                v = iter[k];
                // change "5" to "5px" - unless you're line-height, which is allowed
                (p = styleProperty(k)) && digit.test(v) && !(p in unitless) && (v += px)
                el.style[p] = setter(el, v)
              }
            }
          }
          return this.each(fn)
        }
  
      , offset: function (x, y) {
          if (typeof x == 'number' || typeof y == 'number') {
            return this.each(function (el) {
              xy(el, x, y)
            })
          }
          if (!this[0]) return {
              top: 0
            , left: 0
            , height: 0
            , width: 0
          }
          var el = this[0]
            , width = el.offsetWidth
            , height = el.offsetHeight
            , top = el.offsetTop
            , left = el.offsetLeft
          while (el = el.offsetParent) {
            top = top + el.offsetTop
            left = left + el.offsetLeft
          }
  
          return {
              top: top
            , left: left
            , height: height
            , width: width
          }
        }
  
      , dim: function () {
          var el = this[0]
            , orig = !el.offsetWidth && !el.offsetHeight ?
               // el isn't visible, can't be measured properly, so fix that
               function (t, s) {
                  s = {
                      position: el.style.position || ''
                    , visibility: el.style.visibility || ''
                    , display: el.style.display || ''
                  }
                  t.first().css({
                      position: 'absolute'
                    , visibility: 'hidden'
                    , display: 'block'
                  })
                  return s
                }(this) : null
            , width = el.offsetWidth
            , height = el.offsetHeight
  
          orig && this.first().css(orig)
          return {
              height: height
            , width: width
          }
        }
  
      , attr: function (k, v) {
          var el = this[0]
          if (typeof k != 'string' && !(k instanceof String)) {
            for (var n in k) {
              k.hasOwnProperty(n) && this.attr(n, k[n])
            }
            return this
          }
          return typeof v == 'undefined' ?
            specialAttributes.test(k) ?
              stateAttributes.test(k) && typeof el[k] == 'string' ?
                true : el[k] : (k == 'href' || k =='src') && features.hrefExtended ?
                  el[getAttribute](k, 2) : el[getAttribute](k) :
            this.each(function (el) {
              specialAttributes.test(k) ? (el[k] = setter(el, v)) : el[setAttribute](k, setter(el, v))
            })
        }
  
      , val: function (s) {
          return (typeof s == 'string') ? this.attr('value', s) : this[0].value
        }
  
      , removeAttr: function (k) {
          return this.each(function (el) {
            stateAttributes.test(k) ? (el[k] = false) : el.removeAttribute(k)
          })
        }
  
      , data: function (k, v) {
          var el = this[0], uid, o, m
          if (typeof v === 'undefined') {
            o = data(el)
            if (typeof k === 'undefined') {
              each(el.attributes, function(a) {
                (m = (''+a.name).match(dattr)) && (o[camelize(m[1])] = dataValue(a.value))
              })
              return o
            } else {
              return typeof o[k] === 'undefined' ?
                (o[k] = dataValue(this.attr('data-' + decamelize(k)))) : o[k]
            }
          } else {
            return this.each(function (el) { data(el)[k] = v })
          }
        }
  
      , remove: function () {
          return this.each(function (el) {
            el[parentNode] && el[parentNode].removeChild(el)
          })
        }
  
      , empty: function () {
          return this.each(function (el) {
            while (el.firstChild) {
              el.removeChild(el.firstChild)
            }
          })
        }
  
      , detach: function () {
          return this.map(function (el) {
            return el[parentNode].removeChild(el)
          })
        }
  
      , scrollTop: function (y) {
          return scroll.call(this, null, y, 'y')
        }
  
      , scrollLeft: function (x) {
          return scroll.call(this, x, null, 'x')
        }
  
      , toggle: function(callback) {
          this.each(function (el) {
            el.style.display = (el.offsetWidth || el.offsetHeight) ? 'none' : 'block'
          })
          callback && callback()
          return this
        }
    }
  
    function normalize(node) {
      return typeof node == 'string' ? bonzo.create(node) : isNode(node) ? [node] : node // assume [nodes]
    }
  
    function scroll(x, y, type) {
      var el = this[0]
      if (x == null && y == null) {
        return (isBody(el) ? getWindowScroll() : { x: el.scrollLeft, y: el.scrollTop })[type]
      }
      if (isBody(el)) {
        win.scrollTo(x, y)
      } else {
        x != null && (el.scrollLeft = x)
        y != null && (el.scrollTop = y)
      }
      return this
    }
  
    function isBody(element) {
      return element === win || (/^(?:body|html)$/i).test(element.tagName)
    }
  
    function getWindowScroll() {
      return { x: win.pageXOffset || html.scrollLeft, y: win.pageYOffset || html.scrollTop }
    }
  
    function bonzo(els, host) {
      return new Bonzo(els, host)
    }
  
    bonzo.setQueryEngine = function (q) {
      query = q;
      delete bonzo.setQueryEngine
    }
  
    bonzo.aug = function (o, target) {
      for (var k in o) {
        o.hasOwnProperty(k) && ((target || Bonzo.prototype)[k] = o[k])
      }
    }
  
    bonzo.create = function (node) {
      return typeof node == 'string' && node !== '' ?
        function () {
          var tag = /^\s*<([^\s>]+)/.exec(node)
            , el = doc.createElement('div')
            , els = []
            , p = tag ? tagMap[tag[1].toLowerCase()] : null
            , dep = p ? p[2] + 1 : 1
            , pn = parentNode
            , tb = features.autoTbody && p && p[0] == '<table>' && !(/<tbody/i).test(node)
  
          el.innerHTML = p ? (p[0] + node + p[1]) : node
          while (dep--) el = el.firstChild
          do {
            // tbody special case for IE<8, creates tbody on any empty table
            // we don't want it if we're just after a <thead>, <caption>, etc.
            if ((!tag || el.nodeType == 1) && (!tb || el.tagName.toLowerCase() != 'tbody')) {
              els.push(el)
            }
          } while (el = el.nextSibling)
          // IE < 9 gives us a parentNode which messes up insert() check for cloning
          // `dep` > 1 can also cause problems with the insert() check (must do this last)
          each(els, function(el) { el[pn] && el[pn].removeChild(el) })
          return els
  
        }() : isNode(node) ? [node.cloneNode(true)] : []
    }
  
    bonzo.doc = function () {
      var vp = bonzo.viewport()
      return {
          width: Math.max(doc.body.scrollWidth, html.scrollWidth, vp.width)
        , height: Math.max(doc.body.scrollHeight, html.scrollHeight, vp.height)
      }
    }
  
    bonzo.firstChild = function (el) {
      for (var c = el.childNodes, i = 0, j = (c && c.length) || 0, e; i < j; i++) {
        if (c[i].nodeType === 1) e = c[j = i]
      }
      return e
    }
  
    bonzo.viewport = function () {
      return {
          width: ie ? html.clientWidth : self.innerWidth
        , height: ie ? html.clientHeight : self.innerHeight
      }
    }
  
    bonzo.isAncestor = 'compareDocumentPosition' in html ?
      function (container, element) {
        return (container.compareDocumentPosition(element) & 16) == 16
      } : 'contains' in html ?
      function (container, element) {
        return container !== element && container.contains(element);
      } :
      function (container, element) {
        while (element = element[parentNode]) {
          if (element === container) {
            return true
          }
        }
        return false
      }
  
    bonzo.noConflict = function () {
      context.bonzo = old
      return this
    }
  
    return bonzo
  })
  

  provide("bonzo", module.exports);

  !function ($) {
  
    var b = require('bonzo')
    b.setQueryEngine($)
    $.ender(b)
    $.ender(b(), true)
    $.ender({
      create: function (node) {
        return $(b.create(node))
      }
    })
  
    $.id = function (id) {
      return $([document.getElementById(id)])
    }
  
    function indexOf(ar, val) {
      for (var i = 0; i < ar.length; i++) {
        if (ar[i] === val) return i
      }
      return -1
    }
  
    function uniq(ar) {
      var a = [], i, j
      label:
      for (i = 0; i < ar.length; i++) {
        for (j = 0; j < a.length; j++) {
          if (a[j] == ar[i]) {
            continue label
          }
        }
        a[a.length] = ar[i]
      }
      return a
    }
  
    $.ender({
      parents: function (selector, closest) {
        var collection = $(selector), j, k, p, r = []
        for (j = 0, k = this.length; j < k; j++) {
          p = this[j]
          while (p = p.parentNode) {
            if (~indexOf(collection, p)) {
              r.push(p)
              if (closest) break;
            }
          }
        }
        return $(uniq(r))
      },
  
      closest: function (selector) {
        return this.parents(selector, true)
      },
  
      first: function () {
        return $(this.length ? this[0] : this)
      },
  
      last: function () {
        return $(this.length ? this[this.length - 1] : [])
      },
  
      next: function () {
        return $(b(this).next())
      },
  
      previous: function () {
        return $(b(this).previous())
      },
  
      appendTo: function (t) {
        return b(this.selector).appendTo(t, this)
      },
  
      prependTo: function (t) {
        return b(this.selector).prependTo(t, this)
      },
  
      insertAfter: function (t) {
        return b(this.selector).insertAfter(t, this)
      },
  
      insertBefore: function (t) {
        return b(this.selector).insertBefore(t, this)
      },
  
      siblings: function () {
        var i, l, p, r = []
        for (i = 0, l = this.length; i < l; i++) {
          p = this[i]
          while (p = p.previousSibling) p.nodeType == 1 && r.push(p)
          p = this[i]
          while (p = p.nextSibling) p.nodeType == 1 && r.push(p)
        }
        return $(r)
      },
  
      children: function () {
        var i, el, r = []
        for (i = 0, l = this.length; i < l; i++) {
          if (!(el = b.firstChild(this[i]))) continue;
          r.push(el)
          while (el = el.nextSibling) el.nodeType == 1 && r.push(el)
        }
        return $(uniq(r))
      },
  
      height: function (v) {
        return dimension(v, this, 'height')
      },
  
      width: function (v) {
        return dimension(v, this, 'width')
      }
    }, true)
  
    function dimension(v, self, which) {
      return v ?
        self.css(which, v) :
        function (r) {
          if (!self[0]) return 0
          r = parseInt(self.css(which), 10);
          return isNaN(r) ? self[0]['offset' + which.replace(/^\w/, function (m) {return m.toUpperCase()})] : r
        }()
    }
  
  }(ender);
  

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  !function (name, definition) {
    if (typeof define == 'function') define(definition)
    else if (typeof module != 'undefined') module.exports = definition()
    else this[name] = this['domReady'] = definition()
  }('domready', function (ready) {
  
    var fns = [], fn, f = false
      , doc = document
      , testEl = doc.documentElement
      , hack = testEl.doScroll
      , domContentLoaded = 'DOMContentLoaded'
      , addEventListener = 'addEventListener'
      , onreadystatechange = 'onreadystatechange'
      , loaded = /^loade|c/.test(doc.readyState)
  
    function flush(f) {
      loaded = 1
      while (f = fns.shift()) f()
    }
  
    doc[addEventListener] && doc[addEventListener](domContentLoaded, fn = function () {
      doc.removeEventListener(domContentLoaded, fn, f)
      flush()
    }, f)
  
  
    hack && doc.attachEvent(onreadystatechange, (fn = function () {
      if (/^c/.test(doc.readyState)) {
        doc.detachEvent(onreadystatechange, fn)
        flush()
      }
    }))
  
    return (ready = hack ?
      function (fn) {
        self != top ?
          loaded ? fn() : fns.push(fn) :
          function () {
            try {
              testEl.doScroll('left')
            } catch (e) {
              return setTimeout(function() { ready(fn) }, 50)
            }
            fn()
          }()
      } :
      function (fn) {
        loaded ? fn() : fns.push(fn)
      })
  })

  provide("domready", module.exports);

  !function ($) {
    var ready = require('domready')
    $.ender({domReady: ready})
    $.ender({
      ready: function (f) {
        ready(f)
        return this
      }
    }, true)
  }(ender);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*!
    * Qwery - A Blazing Fast query selector engine
    * https://github.com/ded/qwery
    * copyright Dustin Diaz & Jacob Thornton 2011
    * MIT License
    */
  
  !function (name, definition) {
    if (typeof module != 'undefined') module.exports = definition()
    else if (typeof define == 'function' && typeof define.amd == 'object') define(definition)
    else this[name] = definition()
  }('qwery', function () {
    var context = this
      , doc = document
      , old = context.qwery
      , html = doc.documentElement
      , byClass = 'getElementsByClassName'
      , byTag = 'getElementsByTagName'
      , byId = 'getElementById'
      , qSA = 'querySelectorAll'
      , id = /#([\w\-]+)/
      , clas = /\.[\w\-]+/g
      , idOnly = /^#([\w\-]+)$/
      , classOnly = /^\.([\w\-]+)$/
      , tagOnly = /^([\w\-]+)$/
      , tagAndOrClass = /^([\w]+)?\.([\w\-]+)$/
      , easy = new RegExp(idOnly.source + '|' + tagOnly.source + '|' + classOnly.source)
      , splittable = /(^|,)\s*[>~+]/
      , normalizr = /^\s+|\s*([,\s\+\~>]|$)\s*/g
      , splitters = /[\s\>\+\~]/
      , splittersMore = /(?![\s\w\-\/\?\&\=\:\.\(\)\!,@#%<>\{\}\$\*\^'"]*\]|[\s\w\+\-]*\))/
      , specialChars = /([.*+?\^=!:${}()|\[\]\/\\])/g
      , simple = /^([a-z0-9]+)?(?:([\.\#]+[\w\-\.#]+)?)/
      , attr = /\[([\w\-]+)(?:([\|\^\$\*\~]?\=)['"]?([ \w\-\/\?\&\=\:\.\(\)\!,@#%<>\{\}\$\*\^]+)["']?)?\]/
      , pseudo = /:([\w\-]+)(\(['"]?([\s\w\+\-]+)['"]?\))?/
      , dividers = new RegExp('(' + splitters.source + ')' + splittersMore.source, 'g')
      , tokenizr = new RegExp(splitters.source + splittersMore.source)
      , chunker = new RegExp(simple.source + '(' + attr.source + ')?' + '(' + pseudo.source + ')?')
      , walker = {
          ' ': function (node) {
            return node && node !== html && node.parentNode
          }
        , '>': function (node, contestant) {
            return node && node.parentNode == contestant.parentNode && node.parentNode
          }
        , '~': function (node) {
            return node && node.previousSibling
          }
        , '+': function (node, contestant, p1, p2) {
            if (!node) return false
            return (p1 = previous(node)) && (p2 = previous(contestant)) && p1 == p2 && p1
          }
        }
  
    function cache() {
      this.c = {}
    }
    cache.prototype = {
        g: function (k) {
          return this.c[k] || undefined
        }
      , s: function (k, v) {
          return (this.c[k] = v)
        }
    }
  
    var classCache = new cache()
      , cleanCache = new cache()
      , attrCache = new cache()
      , tokenCache = new cache()
  
    function classRegex(c) {
      return classCache.g(c) || classCache.s(c, new RegExp('(^|\\s+)' + c + '(\\s+|$)'));
    }
  
    // not quite as fast as inline loops in older browsers so don't use liberally
    function each(a, fn) {
      var i = 0, l = a.length
      for (; i < l; i++) fn.call(null, a[i])
    }
  
    function flatten(ar) {
      var r = []
      each(ar, function(a) {
        if (arrayLike(a)) r = r.concat(a)
        else r[r.length] = a
      });
      return r
    }
  
    function arrayify(ar) {
      var i = 0, l = ar.length, r = []
      for (; i < l; i++) r[i] = ar[i]
      return r
    }
  
    function previous(n) {
      while (n = n.previousSibling) if (n.nodeType == 1) break;
      return n
    }
  
    function q(query) {
      return query.match(chunker)
    }
  
    // called using `this` as element and arguments from regex group results.
    // given => div.hello[title="world"]:foo('bar')
    // div.hello[title="world"]:foo('bar'), div, .hello, [title="world"], title, =, world, :foo('bar'), foo, ('bar'), bar]
    function interpret(whole, tag, idsAndClasses, wholeAttribute, attribute, qualifier, value, wholePseudo, pseudo, wholePseudoVal, pseudoVal) {
      var i, m, k, o, classes
      if (tag && this.tagName.toLowerCase() !== tag) return false
      if (idsAndClasses && (m = idsAndClasses.match(id)) && m[1] !== this.id) return false
      if (idsAndClasses && (classes = idsAndClasses.match(clas))) {
        for (i = classes.length; i--;) {
          if (!classRegex(classes[i].slice(1)).test(this.className)) return false
        }
      }
      if (pseudo && qwery.pseudos[pseudo] && !qwery.pseudos[pseudo](this, pseudoVal)) {
        return false
      }
      if (wholeAttribute && !value) { // select is just for existance of attrib
        o = this.attributes
        for (k in o) {
          if (Object.prototype.hasOwnProperty.call(o, k) && (o[k].name || k) == attribute) {
            return this
          }
        }
      }
      if (wholeAttribute && !checkAttr(qualifier, getAttr(this, attribute) || '', value)) {
        // select is for attrib equality
        return false
      }
      return this
    }
  
    function clean(s) {
      return cleanCache.g(s) || cleanCache.s(s, s.replace(specialChars, '\\$1'))
    }
  
    function checkAttr(qualify, actual, val) {
      switch (qualify) {
      case '=':
        return actual == val
      case '^=':
        return actual.match(attrCache.g('^=' + val) || attrCache.s('^=' + val, new RegExp('^' + clean(val))))
      case '$=':
        return actual.match(attrCache.g('$=' + val) || attrCache.s('$=' + val, new RegExp(clean(val) + '$')))
      case '*=':
        return actual.match(attrCache.g(val) || attrCache.s(val, new RegExp(clean(val))))
      case '~=':
        return actual.match(attrCache.g('~=' + val) || attrCache.s('~=' + val, new RegExp('(?:^|\\s+)' + clean(val) + '(?:\\s+|$)')))
      case '|=':
        return actual.match(attrCache.g('|=' + val) || attrCache.s('|=' + val, new RegExp('^' + clean(val) + '(-|$)')))
      }
      return 0
    }
  
    // given a selector, first check for simple cases then collect all base candidate matches and filter
    function _qwery(selector) {
      var r = [], ret = [], i, l, m, token, tag, els, root, intr, item
        , tokens = tokenCache.g(selector) || tokenCache.s(selector, selector.split(tokenizr))
        , dividedTokens = selector.match(dividers)
  
      if (!tokens.length) return r
      tokens = tokens.slice(0) // this makes a copy of the array so the cached original is not affected
  
      token = tokens.pop()
      root = tokens.length && (m = tokens[tokens.length - 1].match(idOnly)) ? doc[byId](m[1]) : doc
      if (!root) return r
  
      intr = q(token)
      // collect base candidates to filter
      els = root.nodeType !== 9 && dividedTokens && /^[+~]$/.test(dividedTokens[dividedTokens.length - 1]) ?
        function (r) {
          while (root = root.nextSibling) {
            root.nodeType == 1 && (intr[1] ? intr[1] == root.tagName.toLowerCase() : 1) && (r[r.length] = root)
          }
          return r
        }([]) :
        root[byTag](intr[1] || '*')
      // filter elements according to the right-most part of the selector
      for (i = 0, l = els.length; i < l; i++) {
        if (item = interpret.apply(els[i], intr)) r[r.length] = item
      }
      if (!tokens.length) return r
  
      // filter further according to the rest of the selector (the left side)
      each(r, function(e) { if (ancestorMatch(e, tokens, dividedTokens)) ret[ret.length] = e })
      return ret
    }
  
    // compare element to a selector
    function is(el, selector, root) {
      if (isNode(selector)) return el == selector
      if (arrayLike(selector)) return !!~flatten(selector).indexOf(el) // if selector is an array, is el a member?
  
      var selectors = selector.split(','), tokens, dividedTokens
      while (selector = selectors.pop()) {
        tokens = tokenCache.g(selector) || tokenCache.s(selector, selector.split(tokenizr))
        dividedTokens = selector.match(dividers)
        tokens = tokens.slice(0) // copy array
        if (interpret.apply(el, q(tokens.pop())) && (!tokens.length || ancestorMatch(el, tokens, dividedTokens, root))) {
          return true
        }
      }
    }
  
    // given elements matching the right-most part of a selector, filter out any that don't match the rest
    function ancestorMatch(el, tokens, dividedTokens, root) {
      var cand
      // recursively work backwards through the tokens and up the dom, covering all options
      function crawl(e, i, p) {
        while (p = walker[dividedTokens[i]](p, e)) {
          if (isNode(p) && (found = interpret.apply(p, q(tokens[i])))) {
            if (i) {
              if (cand = crawl(p, i - 1, p)) return cand
            } else return p
          }
        }
      }
      return (cand = crawl(el, tokens.length - 1, el)) && (!root || isAncestor(cand, root))
    }
  
    function isNode(el) {
      return el && typeof el === 'object' && el.nodeType && (el.nodeType == 1 || el.nodeType == 9)
    }
  
    function uniq(ar) {
      var a = [], i, j;
      label:
      for (i = 0; i < ar.length; i++) {
        for (j = 0; j < a.length; j++) {
          if (a[j] == ar[i]) continue label;
        }
        a[a.length] = ar[i]
      }
      return a
    }
  
    function arrayLike(o) {
      return (typeof o === 'object' && isFinite(o.length))
    }
  
    function normalizeRoot(root) {
      if (!root) return doc
      if (typeof root == 'string') return qwery(root)[0]
      if (arrayLike(root)) return root[0]
      return root
    }
  
    function qwery(selector, _root) {
      var m, el, root = normalizeRoot(_root)
  
      // easy, fast cases that we can dispatch with simple DOM calls
      if (!root || !selector) return []
      if (selector === window || isNode(selector)) {
        return !_root || (selector !== window && isNode(root) && isAncestor(selector, root)) ? [selector] : []
      }
      if (selector && arrayLike(selector)) return flatten(selector)
      if (m = selector.match(easy)) {
        if (m[1]) return (el = doc[byId](m[1])) ? [el] : []
        if (m[2]) return arrayify(root[byTag](m[2]))
        if (supportsCSS3 && m[3]) return arrayify(root[byClass](m[3]))
      }
  
      return select(selector, root)
    }
  
    // where the root is not document and a relationship selector is first we have to
    // do some awkward adjustments to get it to work, even with qSA
    function collectSelector(root, collector) {
      return function(s) {
        var oid, nid
        if (splittable.test(s)) {
          if (root !== doc) {
           // make sure the el has an id, rewrite the query, set root to doc and run it
           if (!(nid = oid = root.getAttribute('id'))) root.setAttribute('id', nid = '__qwerymeupscotty')
           s = '#' + nid + s
           collector(doc, s)
           oid || root.removeAttribute('id')
          }
          return;
        }
        s.length && collector(root, s)
      }
    }
  
    var isAncestor = 'compareDocumentPosition' in html ?
      function (element, container) {
        return (container.compareDocumentPosition(element) & 16) == 16
      } : 'contains' in html ?
      function (element, container) {
        container = container == doc || container == window ? html : container
        return container !== element && container.contains(element)
      } :
      function (element, container) {
        while (element = element.parentNode) if (element === container) return 1
        return 0
      }
    , getAttr = function() {
        // detect buggy IE src/href getAttribute() call
        var e = doc.createElement('p')
        return ((e.innerHTML = '<a href="#x">x</a>') && e.firstChild.getAttribute('href') != '#x') ?
          function(e, a) {
            return a === 'class' ? e.className : (a === 'href' || a === 'src') ?
              e.getAttribute(a, 2) : e.getAttribute(a)
          } :
          function(e, a) { return e.getAttribute(a) }
     }()
    , supportsCSS3 = function () {
        // does native qSA support CSS3 level selectors
        try {
          return doc[byClass] && doc.querySelector && doc[qSA] && doc[qSA](':nth-of-type(1)').length
        } catch (e) { return false }
      }()
    , select = supportsCSS3 ?
      function (selector, root) {
        var result = [], ss, e
        if (root === doc || !splittable.test(selector)) {
          // most work is done right here, defer to qSA
          return arrayify(root[qSA](selector))
        }
        // special case where we need the services of `collectSelector()`
        each(ss = selector.split(','), collectSelector(root, function(ctx, s) {
          e = ctx[qSA](s)
          if (e.length == 1) result[result.length] = e.item(0)
          else if (e.length) result = result.concat(arrayify(e))
        }))
        return ss.length > 1 && result.length > 1 ? uniq(result) : result
      } :
      function (selector, root) {
        var result = [], m, i, l, r, ss
        selector = selector.replace(normalizr, '$1')
        if (m = selector.match(tagAndOrClass)) {
          // simple & common case, safe to use non-CSS3 qSA if present
          if (root[qSA]) return arrayify(root[qSA](selector))
          r = classRegex(m[2])
          items = root[byTag](m[1] || '*')
          for (i = 0, l = items.length; i < l; i++) {
            if (r.test(items[i].className)) result[result.length] = items[i]
          }
          return result
        }
        // more complex selector, get `_qwery()` to do the work for us
        each(ss = selector.split(','), collectSelector(root, function(ctx, s) {
          var i = 0, r = _qwery(s), l = r.length
          for (; i < l; i++) {
            if (ctx === doc || isAncestor(r[i], root)) result[result.length] = r[i]
          }
        }))
        return ss.length > 1 && result.length > 1 ? uniq(result) : result
      }
  
    qwery.uniq = uniq
    qwery.is = is
    qwery.pseudos = {}
  
    qwery.noConflict = function () {
      context.qwery = old
      return this
    }
  
    return qwery
  })
  

  provide("qwery", module.exports);

  !function (doc, $) {
    var q = require('qwery')
      , table = 'table'
      , nodeMap = {
            thead: table
          , tbody: table
          , tfoot: table
          , tr: 'tbody'
          , th: 'tr'
          , td: 'tr'
          , fieldset: 'form'
          , option: 'select'
        }
    function create(node, root) {
      var tag = /^\s*<([^\s>]+)\s*/.exec(node)[1]
        , el = (root || doc).createElement(nodeMap[tag] || 'div'), els = []
  
      el.innerHTML = node
      var nodes = el.childNodes
      el = el.firstChild
      el.nodeType == 1 && els.push(el)
      while (el = el.nextSibling) (el.nodeType == 1) && els.push(el)
      return els
    }
  
    $._select = function (s, r) {
      return /^\s*</.test(s) ? create(s, r) : q(s, r)
    }
  
    $.pseudos = q.pseudos
  
    $.ender({
      find: function (s) {
        var r = [], i, l, j, k, els
        for (i = 0, l = this.length; i < l; i++) {
          els = q(s, this[i])
          for (j = 0, k = els.length; j < k; j++) r.push(els[j])
        }
        return $(q.uniq(r))
      }
      , and: function (s) {
        var plus = $(s)
        for (var i = this.length, j = 0, l = this.length + plus.length; i < l; i++, j++) {
          this[i] = plus[j]
        }
        return this
      }
      , is: function(s, r) {
        var i, l
        for (i = 0, l = this.length; i < l; i++) {
          if (q.is(this[i], s, r)) {
            return true
          }
        }
        return false
      }
    }, true)
  }(document, ender);
  

}();



!function () {

  var module = { exports: {} }, exports = module.exports;

  if ('undefined' === typeof process) {
    process = {};
  }
  (function () {
    "use strict";
  
    process.EventEmitter = process.EventEmitter || function () {};
  
  // Copyright Joyent, Inc. and other Node contributors.
  //
  // Permission is hereby granted, free of charge, to any person obtaining a
  // copy of this software and associated documentation files (the
  // "Software"), to deal in the Software without restriction, including
  // without limitation the rights to use, copy, modify, merge, publish,
  // distribute, sublicense, and/or sell copies of the Software, and to permit
  // persons to whom the Software is furnished to do so, subject to the
  // following conditions:
  //
  // The above copyright notice and this permission notice shall be included
  // in all copies or substantial portions of the Software.
  //
  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
  // USE OR OTHER DEALINGS IN THE SOFTWARE.
  
  var EventEmitter = exports.EventEmitter = process.EventEmitter;
  var isArray = Array.isArray;
  
  // By default EventEmitters will print a warning if more than
  // 10 listeners are added to it. This is a useful default which
  // helps finding memory leaks.
  //
  // Obviously not all Emitters should be limited to 10. This function allows
  // that to be increased. Set to zero for unlimited.
  var defaultMaxListeners = 10;
  EventEmitter.prototype.setMaxListeners = function(n) {
    if (!this._events) this._events = {};
    this._events.maxListeners = n;
  };
  
  
  EventEmitter.prototype.emit = function(type) {
    // If there is no 'error' event listener then throw.
    if (type === 'error') {
      if (!this._events || !this._events.error ||
          (isArray(this._events.error) && !this._events.error.length))
      {
        if (arguments[1] instanceof Error) {
          throw arguments[1]; // Unhandled 'error' event
        } else {
          throw new Error("Uncaught, unspecified 'error' event.");
        }
        return false;
      }
    }
  
    if (!this._events) return false;
    var handler = this._events[type];
    if (!handler) return false;
  
    if (typeof handler == 'function') {
      switch (arguments.length) {
        // fast cases
        case 1:
          handler.call(this);
          break;
        case 2:
          handler.call(this, arguments[1]);
          break;
        case 3:
          handler.call(this, arguments[1], arguments[2]);
          break;
        // slower
        default:
          var args = Array.prototype.slice.call(arguments, 1);
          handler.apply(this, args);
      }
      return true;
  
    } else if (isArray(handler)) {
      var args = Array.prototype.slice.call(arguments, 1);
  
      var listeners = handler.slice();
      for (var i = 0, l = listeners.length; i < l; i++) {
        listeners[i].apply(this, args);
      }
      return true;
  
    } else {
      return false;
    }
  };
  
  // EventEmitter is defined in src/node_events.cc
  // EventEmitter.prototype.emit() is also defined there.
  EventEmitter.prototype.addListener = function(type, listener) {
    if ('function' !== typeof listener) {
      throw new Error('addListener only takes instances of Function');
    }
  
    if (!this._events) this._events = {};
  
    // To avoid recursion in the case that type == "newListeners"! Before
    // adding it to the listeners, first emit "newListeners".
    this.emit('newListener', type, listener);
  
    if (!this._events[type]) {
      // Optimize the case of one listener. Don't need the extra array object.
      this._events[type] = listener;
    } else if (isArray(this._events[type])) {
  
      // If we've already got an array, just append.
      this._events[type].push(listener);
  
      // Check for listener leak
      if (!this._events[type].warned) {
        var m;
        if (this._events.maxListeners !== undefined) {
          m = this._events.maxListeners;
        } else {
          m = defaultMaxListeners;
        }
  
        if (m && m > 0 && this._events[type].length > m) {
          this._events[type].warned = true;
          console.error('(node) warning: possible EventEmitter memory ' +
                        'leak detected. %d listeners added. ' +
                        'Use emitter.setMaxListeners() to increase limit.',
                        this._events[type].length);
          console.trace();
        }
      }
    } else {
      // Adding the second element, need to change to array.
      this._events[type] = [this._events[type], listener];
    }
  
    return this;
  };
  
  EventEmitter.prototype.on = EventEmitter.prototype.addListener;
  
  EventEmitter.prototype.once = function(type, listener) {
    var self = this;
    function g() {
      self.removeListener(type, g);
      listener.apply(this, arguments);
    };
  
    g.listener = listener;
    self.on(type, g);
  
    return this;
  };
  
  EventEmitter.prototype.removeListener = function(type, listener) {
    if ('function' !== typeof listener) {
      throw new Error('removeListener only takes instances of Function');
    }
  
    // does not use listeners(), so no side effect of creating _events[type]
    if (!this._events || !this._events[type]) return this;
  
    var list = this._events[type];
  
    if (isArray(list)) {
      var position = -1;
      for (var i = 0, length = list.length; i < length; i++) {
        if (list[i] === listener ||
            (list[i].listener && list[i].listener === listener))
        {
          position = i;
          break;
        }
      }
  
      if (position < 0) return this;
      list.splice(position, 1);
      if (list.length == 0)
        delete this._events[type];
    } else if (list === listener ||
               (list.listener && list.listener === listener))
    {
      delete this._events[type];
    }
  
    return this;
  };
  
  EventEmitter.prototype.removeAllListeners = function(type) {
    // does not use listeners(), so no side effect of creating _events[type]
    if (type && this._events && this._events[type]) this._events[type] = null;
    return this;
  };
  
  EventEmitter.prototype.listeners = function(type) {
    if (!this._events) this._events = {};
    if (!this._events[type]) this._events[type] = [];
    if (!isArray(this._events[type])) {
      this._events[type] = [this._events[type]];
    }
    return this._events[type];
  };
  
  }());
  

  provide("events.node", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function () {
    "use strict";
  
    var MAX_INT = Math.pow(2,52);
  
    function isFuture(obj) {
      return obj instanceof future;
    }
  
    function futureTimeout(time) {
      this.name = "FutureTimeout";
      this.message = "timeout " + time + "ms";
    }
  
  
  
    function future(global_context) {
      var everytimers = {},
        onetimers = {},
        index = 0,
        deliveries = 0,
        time = 0,
        fulfilled,
        data,
        timeout_id,
        //asap = false,
        asap =  true,
        passenger,
        self = this;
  
      // TODO change `null` to `this`
      global_context = ('undefined' === typeof global_context ? null : global_context);
  
  
      function resetTimeout() {
        if (timeout_id) {
          clearTimeout(timeout_id);
          timeout_id = undefined;
        }
  
        if (time > 0) {
          timeout_id = setTimeout(function () {
            self.deliver(new futureTimeout(time));
            timeout_id = undefined;
          }, time);
        }
      }
  
  
  
      self.isFuture = isFuture;
  
      self.setContext = function (context) {
        global_context = context;
      };
  
      self.setTimeout = function (new_time) {
        time = new_time;
        resetTimeout();
      };
  
  
  
      self.errback = function () {
        if (arguments.length < 2) {
          self.deliver.call(self, arguments[0] || new Error("`errback` called without Error"));
        } else {
          self.deliver.apply(self, arguments);
        }
      };
  
  
  
      self.callback = function () {
        var args = Array.prototype.slice.call(arguments);
  
        args.unshift(undefined);
        self.deliver.apply(self, args);
      };
  
  
  
      self.callbackCount = function() {
        return Object.keys(everytimers).length;
      };
  
  
  
      self.deliveryCount = function() {
        return deliveries;
      };
  
  
  
      self.setAsap = function(new_asap) {
        if (undefined === new_asap) {
          new_asap = true;
        }
        if (true !== new_asap && false !== new_asap) {
          throw new Error("Future.setAsap(asap) accepts literal true or false, not " + new_asap);
        }
        asap = new_asap;
      };
  
  
  
      // this will probably never get called and, hence, is not yet well tested
      function cleanup() {
        var new_everytimers = {},
          new_onetimers = {};
  
        index = 0;
        Object.keys(everytimers).forEach(function (id) {
          var newtimer = new_everytimers[index] = everytimers[id];
  
          if (onetimers[id]) {
            new_onetimers[index] = true;
          }
  
          newtimer.id = index;
          index += 1;
        });
  
        onetimers = new_onetimers;
        everytimers = new_everytimers;
      }
  
  
  
      function findCallback(callback, context) {
        var result;
        Object.keys(everytimers).forEach(function (id) {
          var everytimer = everytimers[id];
          if (callback === everytimer.callback) {
            if (context === everytimer.context || everytimer.context === global_context) {
              result = everytimer;
            }
          }
        });
        return result;
      }
  
  
  
      self.hasCallback = function () {
        return !!findCallback.apply(self, arguments);
      };
  
  
  
      self.removeCallback = function(callback, context) {
        var everytimer = findCallback(callback, context);
        if (everytimer) {
          delete everytimers[everytimer.id];
          onetimers[everytimer.id] = undefined;
          delete onetimers[everytimer.id];
        }
  
        return self;
      };
  
  
  
      self.deliver = function() {
        if (fulfilled) {
          throw new Error("`Future().fulfill(err, data, ...)` renders future deliveries useless");
        }
        var args = Array.prototype.slice.call(arguments);
        data = args;
  
        deliveries += 1; // Eventually reaches `Infinity`...
  
        Object.keys(everytimers).forEach(function (id) {
          var everytimer = everytimers[id],
            callback = everytimer.callback,
            context = everytimer.context;
  
          if (onetimers[id]) {
            delete everytimers[id];
            delete onetimers[id];
          }
  
          // TODO
          callback.apply(context, args);
          /*
          callback.apply(('undefined' !== context ? context : newme), args);
          context = newme;
          context = ('undefined' !== global_context ? global_context : context)
          context = ('undefined' !== local_context ? local_context : context)
          */
        });
  
        if (args[0] && "FutureTimeout" !== args[0].name) {
          resetTimeout();
        }
  
        return self;
      };
  
  
  
      self.fulfill = function () {
        if (arguments.length) {
          self.deliver.apply(self, arguments);
        } else {
          self.deliver();
        }
        fulfilled = true;
      };
  
  
  
      self.whenever = function (callback, local_context) {
        var id = index,
          everytimer;
  
        if ('function' !== typeof callback) {
          throw new Error("Future().whenever(callback, [context]): callback must be a function.");
        }
  
        if (findCallback(callback, local_context)) {
          // TODO log
          throw new Error("Future().everytimers is a strict set. Cannot add already subscribed `callback, [context]`.");
          return;
        }
  
        everytimer = everytimers[id] = {
          id: id,
          callback: callback,
          context: (null === local_context) ? null : (local_context || global_context)
        };
  
        if (asap && deliveries > 0) {
          // doesn't raise deliver count on purpose
          everytimer.callback.apply(everytimer.context, data);
          if (onetimers[id]) {
            delete onetimers[id];
            delete everytimers[id];
          }
        }
  
        index += 1;
        if (index >= MAX_INT) {
          cleanup(); // Works even for long-running processes
        }
  
        return self;
      };
  
  
  
      self.when = function (callback, local_context) {
        // this index will be the id of the everytimer
        onetimers[index] = true;
        self.whenever(callback, local_context);
  
        return self;
      };
  
  
      //
      function privatize(obj, pubs) {
        var result = {};
        pubs.forEach(function (pub) {
          result[pub] = function () {
            obj[pub].apply(obj, arguments);
            return result;
          };
        });
        return result;
      }
  
      passenger = privatize(self, [
        "when",
        "whenever"
      ]);
  
      self.passable = function () {
        return passenger;
      };
  
    }
  
    function Future(context) {
      // TODO use prototype instead of new
      return (new future(context));
    }
  
    Future.isFuture = isFuture;
    module.exports = Future;
  }());
  

  provide("future", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function () {
    "use strict";
  
    function isSequence(obj) {
      return obj instanceof sequence;
    }
  
    function sequence(global_context) {
      var self = this,
        waiting = true,
        data,
        stack = [];
  
      global_context = global_context || null;
  
      function next() {
        var args = Array.prototype.slice.call(arguments),
          seq = stack.shift(); // BUG this will eventually leak
  
        data = arguments;
  
        if (!seq) {
          // the chain has ended (for now)
          waiting = true;
          return;
        }
  
        args.unshift(next);
        seq.callback.apply(seq.context, args);
      }
  
      function then(callback, context) {
        if ('function' !== typeof callback) {
          throw new Error("`Sequence().then(callback [context])` requires that `callback` be a function and that `context` be `null`, an object, or a function");
        }
        stack.push({
          callback: callback,
          context: (null === context ? null : context || global_context),
          index: stack.length
        });
  
        // if the chain has stopped, start it back up
        if (waiting) {
          waiting = false;
          next.apply(null, data);
        }
  
        return self;
      }
  
      self.next = next;
      self.then = then;
    }
  
    function Sequence(context) {
      // TODO use prototype instead of new
      return (new sequence(context));
    }
    Sequence.isSequence = isSequence;
    module.exports = Sequence;
  }());
  

  provide("sequence", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function () {
    "use strict";
  
    var Future = require('future');
  
    function asyncify(doStuffSync, context) {
      var future = Future(),
        passenger = future.passable();
  
      future.setAsap(false);
  
      function doStuff() {
        var self = ('undefined' !== typeof context ? context : this),
          err,
          data;
  
        future.setContext(self);
  
        try {
          data = doStuffSync.apply(self, arguments);
        } catch(e) {
          err = e;
        }
  
        future.deliver(err, data);
  
        return passenger;
      }
  
      doStuff.when = passenger.when;
      doStuff.whenever = passenger.whenever;
  
      return doStuff;
    }
  
    module.exports = asyncify;
  }());
  

  provide("asyncify", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function () {
    "use strict";
  
    var Future = require('future'),
      Sequence = require('sequence');
  
    // This is being saved in case I later decide to require future-functions
    // rather than always passing `next`
    function handleResult(next, result) {
      // Do wait up; assume that any return value has a callback
      if ('undefined' !== typeof result) {
        if ('function' === typeof result.when) {
          result.when(next);
        } else if ('function' === typeof result) {
          result(next);
        } else {
          next(result);
        }
      }
    }
  
    /**
     * Async Method Queing
     */
    function Chainify(providers, modifiers, consumers, context, params) {
      var Model = {};
  
      if ('undefined' === typeof context) {
        context = null;
      }
  
      /**
       * Create a method from a consumer
       * These may be promisable (validate e-mail addresses by sending an e-mail)
       * or return synchronously (selecting a random number of friends from contacts)
       */
      function methodify(provider, sequence) {
        var methods = {};
  
        function chainify_one(callback, is_consumer) {
          return function () {
            var params = Array.prototype.slice.call(arguments);
  
            sequence.then(function() {
              var args = Array.prototype.slice.call(arguments)
                , args_params = []
                , next = args.shift();
  
              args.forEach(function (arg) {
                args_params.push(arg);
              });
              params.forEach(function (param) {
                args_params.push(param);
              });
              params = undefined;
  
              if (is_consumer) {
                // Don't wait up, just keep on truckin'
                callback.apply(context, args_params);
                next.apply(null, args);
              } else {
                // Do wait up
                args_params.unshift(next);
                callback.apply(context, args_params);
              }
  
              // or
              // handleResult(next, result)
            });
            return methods;
          };
        }
  
        Object.keys(modifiers).forEach(function (key) {
          methods[key] = chainify_one(modifiers[key]);
        });
  
        Object.keys(consumers).forEach(function (key) {
          methods[key] = chainify_one(consumers[key], true);
        });
  
        return methods;
      }
  
      /**
       * A model might be something such as Contacts
       * The providers might be methods such as:
       * all(), one(id), some(ids), search(key, params), search(func), scrape(template)
       */
      function chainify(provider, key) {
        return function () {
          var args = Array.prototype.slice.call(arguments),
            future = Future(),
            sequence = Sequence();
  
          // provide a `next`
          args.unshift(future.deliver);
          provider.apply(context, args);
  
          sequence.then(future.when);
  
          return methodify(providers[key], sequence);
        };
      }
  
      Object.keys(providers).forEach(function (key) {
        Model[key] = chainify(providers[key], key);
      });
  
      return Model;
    }
  
    module.exports = Chainify;
  }());
  

  provide("chainify", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function () {
    "use strict";
  
    var Sequence = require('sequence');
  
    function forEachAsync(arr, callback) {
      var sequence = Sequence();
  
      function handleItem(item, i, arr) {
        sequence.then(function (next) {
          callback(next, item, i, arr);
        });
      }
  
      arr.forEach(handleItem);
  
      return sequence;
    }
  
    module.exports = forEachAsync;
  }());
  

  provide("forEachAsync", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function () {
    "use strict";
  
    var Future = require('future');
  
    function isJoin(obj) {
      return obj instanceof join;
    }
  
    function join(global_context) {
      var self = this,
        data = [],
        ready = [],
        subs = [],
        promise_only = false,
        begun = false,
        updated = 0,
        join_future = Future(global_context);
  
      global_context = global_context || null;
  
      function relay() {
        var i;
        if (!begun || updated !== data.length) {
          return;
        }
        updated = 0;
        join_future.deliver.apply(join_future, data);
        data = Array(data.length);
        ready = Array(ready.length);
        //for (i = 0; i < data.length; i += 1) {
        //  data[i] = undefined;
        //}
      }
  
      function init() {
        var type = (promise_only ? "when" : "whenever");
  
        begun = true;
        data = Array(subs.length);
        ready = Array(subs.length);
  
        subs.forEach(function (sub, id) {
          sub[type](function () {
            var args = Array.prototype.slice.call(arguments);
            data[id] = args;
            if (!ready[id]) {
              ready[id] = true;
              updated += 1;
            }
            relay();
          });
        });
      }
  
      self.deliverer = function () {
        var future = Future();
        self.add(future);
        return future.deliver;
      };
      self.newCallback = self.deliverer;
  
      self.when = function () {
        if (!begun) {
          init();
        }
        join_future.when.apply(join_future, arguments);
      };
  
      self.whenever = function () {
        if (!begun) {
          init();
        }
        join_future.whenever.apply(join_future, arguments);
      };
  
      self.add = function () {
        if (begun) {
          throw new Error("`Join().add(Array<future> | subs1, [subs2, ...])` requires that all additions be completed before the first `when()` or `whenever()`");
        }
        var args = Array.prototype.slice.call(arguments);
        if (0 === args.length) {
          return self.newCallback();
        }
        args = Array.isArray(args[0]) ? args[0] : args;
        args.forEach(function (sub) {
          if (!sub.whenever) {
            promise_only = true;
          }
          if (!sub.when) {
            throw new Error("`Join().add(future)` requires either a promise or future");
          }
          subs.push(sub);
        });
      };
    }
  
    function Join(context) {
      // TODO use prototype instead of new
      return (new join(context));
    }
    Join.isJoin = isJoin;
    module.exports = Join;
  }());
  

  provide("join", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function () {
    "use strict";
  
    var Future = require('future');
  
    function MaxCountReached(max_loops) {
        this.name = "MaxCountReached";
        this.message = "Loop looped " + max_loops + " times";
    }
  
    function timestamp() {
      return (new Date()).valueOf();
    }
  
    function loop(context) {
      var self = this,
        future = Future(),
        min_wait = 0,
        count = 0,
        max_loops = 0,
        latest,
        time,
        timed_out,
        timeout_id,
        data,
        callback;
  
      self.setMaxLoop = function (new_max) {
        max_loops = new_max;
        return self;
      };
  
  
  
      self.setWait = function (new_wait) {
        min_wait = new_wait;
        return self;
      };
  
  
  
      self.setTimeout = function (new_time) {
        if (time) {
          throw new Error("Can't set timeout, the loop has already begun!");
        }
        time = new_time;
        var timeout_id = setTimeout(function () {
          timed_out = true;
          future.deliver(new Error("LoopTimeout"));
        }, time);
  
        future.when(function () {
          clearTimeout(timeout_id);
        });
        return self;
      };
  
  
  
      function runAgain() {
        var wait = Math.max(min_wait - (timestamp() - latest), 0);
        if (isNaN(wait)) {
          wait = min_wait;
        }
  
        if (timed_out) {
          return;
        }
        if (max_loops && count >= max_loops) {
          future.deliver(new MaxCountReached(max_loops));
          return;
        }
  
        data.unshift(next);
        setTimeout(function () {
          latest = timestamp();
          try {
            callback.apply(context, data);
            count += 1;
          } catch(e) {
            throw e;
          }
        }, wait);
      }
  
  
  
      function next() {
        // dirty hack to turn arguments object into an array
        data = Array.prototype.slice.call(arguments);
        if ("break" === data[0]) {
          data.shift();
          future.deliver.apply(future, data);
          return;
        }
        runAgain();
      }
  
  
  
      self.run = function (doStuff) {
        // dirty hack to turn arguments object into an array
        data = Array.prototype.slice.call(arguments);
        callback = doStuff;
        data[0] = undefined;
        next.apply(self, data);
        return self;
      };
  
  
  
      self.when = future.when;
      self.whenever = future.whenever;
  
    }
  
  
  
    function Loop(context) {
      // TODO use prototype instead of new
      return (new loop(context));
    }
    module.exports = Loop;
  }());
  

  provide("loop", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*jslint browser: true, devel: true, debug: true, es5: true, onevar: true, undef: true, nomen: true, eqeqeq: true, plusplus: true, bitwise: true, regexp: true, newcap: true, immed: true, strict: true */
  (function () {
    "use strict";
  
    var modulepath;
  
    function upgradeMessage() {
      var msg = "You have upgraded to Futures 2.x. See http://github.com/coolaj86/futures for details.";
      console.log(msg);
      throw new Error(msg);
    }
  
    module.exports = {
      promise: upgradeMessage,
      subscription: upgradeMessage,
      synchronize: upgradeMessage,
      whilst: upgradeMessage,
      future: require('future'),
      forEachAsync: require('forEachAsync'),
      sequence: require('sequence'),
      join: require('join'),
      asyncify: require('asyncify'),
      loop: require('loop'),
      chainify: require('chainify')
    };
  }());
  

  provide("futures", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*jslint white: false, onevar: true, undef: true, node: true, nomen: true, regexp: false, plusplus: true, bitwise: true, es5: true, newcap: true, maxerr: 5 */
  (function () {
    "use strict";
  
    var utils = exports
      , jsonpRegEx = /\s*([\$\w]+)\s*\(\s*(.*)\s*\)\s*/;
  
    utils.clone = function (obj) {
      return JSON.parse(JSON.stringify(obj));
    };
  
    // useful for extending global options onto a local variable
    utils.extend = function (global, local) {
      //global = utils.clone(global);
      Object.keys(local).forEach(function (key) {
        global[key] = local[key] || global[key];
      });
      return global;
    };
  
    // useful for extending global options onto a local variable
    utils.preset = function (local, global) {
      // TODO copy functions
      // TODO recurse / deep copy
      global = utils.clone(global);
      Object.keys(global).forEach(function (key) {
        if ('undefined' === typeof local[key]) {
          local[key] = global[key];
        }
      });
      return local;
    };
  
    utils.objectToLowerCase = function (obj, recurse) {
      // Make headers all lower-case
      Object.keys(obj).forEach(function (key) {
        var value;
  
        value = obj[key];
        delete obj[key];
        if ('string' === typeof value) {
          obj[key.toLowerCase()] = value.toLowerCase();
        }
      });
      return obj;
    };
  
    utils.parseJsonp = function (jsonpCallback, jsonp) {
      var match = jsonp.match(jsonpRegEx)
        , data
        , json;
  
      if (!match || !match[1] || !match[2]) {
        throw new Error('No JSONP matched');
      }
      if (jsonpCallback !== match[1]) {
        throw new Error('JSONP callback doesn\'t match');
      }
      json = match[2];
  
      data = JSON.parse(json);
      return data;
    };
  
    utils.uriEncodeObject = function(json) {
      var query = '';
  
      try {
        JSON.parse(JSON.stringify(json));
      } catch(e) {
        return 'ERR_CYCLIC_DATA_STRUCTURE';
      }
  
      if ('object' !== typeof json) {
        return 'ERR_NOT_AN_OBJECT';
      }
  
      Object.keys(json).forEach(function (key) {
        var param, value;
  
        // assume that the user meant to delete this element
        if ('undefined' === typeof json[key]) {
          return;
        }
  
        param = encodeURIComponent(key);
        value = encodeURIComponent(json[key]);
        query += '&' + param;
  
        // assume that the user wants just the param name sent
        if (null !== json[key]) {
          query += '=' + value;
        }
      });
  
      // remove first '&'
      return query.substring(1);
    };
  
    utils.addParamsToUri = function(uri, params) {
      var query
        , anchor = ''
        , anchorpos;
  
      uri = uri || "";
      anchor = '';
      params = params || {};
  
      // just in case this gets used client-side
      if (-1 !== (anchorpos = uri.indexOf('#'))) {
        anchor = uri.substr(anchorpos);
        uri = uri.substr(0, anchorpos);
      }
  
      query = utils.uriEncodeObject(params);
  
      // cut the leading '&' if no other params have been written
      if (query.length > 0) {
        if (!uri.match(/\?/)) {
          uri += '?' + query;
        } else {
          uri += '&' + query;
        }
      }
  
      return uri + anchor;
    };
  }());
  

  provide("ahr.utils", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  // Copyright Joyent, Inc. and other Node contributors.
  //
  // Permission is hereby granted, free of charge, to any person obtaining a
  // copy of this software and associated documentation files (the
  // "Software"), to deal in the Software without restriction, including
  // without limitation the rights to use, copy, modify, merge, publish,
  // distribute, sublicense, and/or sell copies of the Software, and to permit
  // persons to whom the Software is furnished to do so, subject to the
  // following conditions:
  //
  // The above copyright notice and this permission notice shall be included
  // in all copies or substantial portions of the Software.
  //
  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
  // USE OR OTHER DEALINGS IN THE SOFTWARE.
  
  // Query String Utilities
  
  (typeof define === "undefined" ? function($) { $(require, exports, module) } : define)(function(require, exports, module, undefined) {
  "use strict";
  
  var QueryString = exports;
  
  function charCode(c) {
    return c.charCodeAt(0);
  }
  
  QueryString.unescape = decodeURIComponent;
  QueryString.escape = encodeURIComponent;
  
  var stringifyPrimitive = function(v) {
    switch (typeof v) {
      case 'string':
        return v;
  
      case 'boolean':
        return v ? 'true' : 'false';
  
      case 'number':
        return isFinite(v) ? v : '';
  
      default:
        return '';
    }
  };
  
  
  QueryString.stringify = QueryString.encode = function(obj, sep, eq, name) {
    sep = sep || '&';
    eq = eq || '=';
    obj = (obj === null) ? undefined : obj;
  
    switch (typeof obj) {
      case 'object':
        return Object.keys(obj).map(function(k) {
          if (Array.isArray(obj[k])) {
            return obj[k].map(function(v) {
              return QueryString.escape(stringifyPrimitive(k)) +
                     eq +
                     QueryString.escape(stringifyPrimitive(v));
            }).join(sep);
          } else {
            return QueryString.escape(stringifyPrimitive(k)) +
                   eq +
                   QueryString.escape(stringifyPrimitive(obj[k]));
          }
        }).join(sep);
  
      default:
        if (!name) return '';
        return QueryString.escape(stringifyPrimitive(name)) + eq +
               QueryString.escape(stringifyPrimitive(obj));
    }
  };
  
  // Parse a key=val string.
  QueryString.parse = QueryString.decode = function(qs, sep, eq) {
    sep = sep || '&';
    eq = eq || '=';
    var obj = {};
  
    if (typeof qs !== 'string' || qs.length === 0) {
      return obj;
    }
  
    qs.split(sep).forEach(function(kvp) {
      var x = kvp.split(eq);
      var k = QueryString.unescape(x[0], true);
      var v = QueryString.unescape(x.slice(1).join(eq), true);
  
      if (!(k in obj)) {
        obj[k] = v;
      } else if (!Array.isArray(obj[k])) {
        obj[k] = [obj[k], v];
      } else {
        obj[k].push(v);
      }
    });
  
    return obj;
  };
  
  });
  

  provide("querystring", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  (function () {
    "use strict";
  
  // Copyright Joyent, Inc. and other Node contributors.
  //
  // Permission is hereby granted, free of charge, to any person obtaining a
  // copy of this software and associated documentation files (the
  // "Software"), to deal in the Software without restriction, including
  // without limitation the rights to use, copy, modify, merge, publish,
  // distribute, sublicense, and/or sell copies of the Software, and to permit
  // persons to whom the Software is furnished to do so, subject to the
  // following conditions:
  //
  // The above copyright notice and this permission notice shall be included
  // in all copies or substantial portions of the Software.
  //
  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
  // USE OR OTHER DEALINGS IN THE SOFTWARE.
  
  exports.parse = urlParse;
  exports.resolve = urlResolve;
  exports.resolveObject = urlResolveObject;
  exports.format = urlFormat;
  
  // Reference: RFC 3986, RFC 1808, RFC 2396
  
  // define these here so at least they only have to be
  // compiled once on the first module load.
  var protocolPattern = /^([a-z0-9]+:)/i,
      portPattern = /:[0-9]+$/,
      // RFC 2396: characters reserved for delimiting URLs.
      delims = ['<', '>', '"', '`', ' ', '\r', '\n', '\t'],
      // RFC 2396: characters not allowed for various reasons.
      unwise = ['{', '}', '|', '\\', '^', '~', '[', ']', '`'].concat(delims),
      // Allowed by RFCs, but cause of XSS attacks.  Always escape these.
      autoEscape = ['\''],
      // Characters that are never ever allowed in a hostname.
      // Note that any invalid chars are also handled, but these
      // are the ones that are *expected* to be seen, so we fast-path
      // them.
      nonHostChars = ['%', '/', '?', ';', '#']
        .concat(unwise).concat(autoEscape),
      nonAuthChars = ['/', '@', '?', '#'].concat(delims),
      hostnameMaxLen = 255,
      hostnamePartPattern = /^[a-zA-Z0-9][a-z0-9A-Z-]{0,62}$/,
      hostnamePartStart = /^([a-zA-Z0-9][a-z0-9A-Z-]{0,62})(.*)$/,
      // protocols that can allow "unsafe" and "unwise" chars.
      unsafeProtocol = {
        'javascript': true,
        'javascript:': true
      },
      // protocols that never have a hostname.
      hostlessProtocol = {
        'javascript': true,
        'javascript:': true
      },
      // protocols that always have a path component.
      pathedProtocol = {
        'http': true,
        'https': true,
        'ftp': true,
        'gopher': true,
        'file': true,
        'http:': true,
        'ftp:': true,
        'gopher:': true,
        'file:': true
      },
      // protocols that always contain a // bit.
      slashedProtocol = {
        'http': true,
        'https': true,
        'ftp': true,
        'gopher': true,
        'file': true,
        'http:': true,
        'https:': true,
        'ftp:': true,
        'gopher:': true,
        'file:': true
      },
      querystring = require('querystring');
  
  function urlParse(url, parseQueryString, slashesDenoteHost) {
    if (url && typeof(url) === 'object' && url.href) return url;
  
    var out = {},
        rest = url;
  
    // cut off any delimiters.
    // This is to support parse stuff like "<http://foo.com>"
    for (var i = 0, l = rest.length; i < l; i++) {
      if (delims.indexOf(rest.charAt(i)) === -1) break;
    }
    if (i !== 0) rest = rest.substr(i);
  
  
    var proto = protocolPattern.exec(rest);
    if (proto) {
      proto = proto[0];
      var lowerProto = proto.toLowerCase();
      out.protocol = lowerProto;
      rest = rest.substr(proto.length);
    }
  
    // figure out if it's got a host
    // user@server is *always* interpreted as a hostname, and url
    // resolution will treat //foo/bar as host=foo,path=bar because that's
    // how the browser resolves relative URLs.
    if (slashesDenoteHost || proto || rest.match(/^\/\/[^@\/]+@[^@\/]+/)) {
      var slashes = rest.substr(0, 2) === '//';
      if (slashes && !(proto && hostlessProtocol[proto])) {
        rest = rest.substr(2);
        out.slashes = true;
      }
    }
  
    if (!hostlessProtocol[proto] &&
        (slashes || (proto && !slashedProtocol[proto]))) {
      // there's a hostname.
      // the first instance of /, ?, ;, or # ends the host.
      // don't enforce full RFC correctness, just be unstupid about it.
  
      // If there is an @ in the hostname, then non-host chars *are* allowed
      // to the left of the first @ sign, unless some non-auth character
      // comes *before* the @-sign.
      // URLs are obnoxious.
      var atSign = rest.indexOf('@');
      if (atSign !== -1) {
        // there *may be* an auth
        var hasAuth = true;
        for (var i = 0, l = nonAuthChars.length; i < l; i++) {
          var index = rest.indexOf(nonAuthChars[i]);
          if (index !== -1 && index < atSign) {
            // not a valid auth.  Something like http://foo.com/bar@baz/
            hasAuth = false;
            break;
          }
        }
        if (hasAuth) {
          // pluck off the auth portion.
          out.auth = rest.substr(0, atSign);
          rest = rest.substr(atSign + 1);
        }
      }
  
      var firstNonHost = -1;
      for (var i = 0, l = nonHostChars.length; i < l; i++) {
        var index = rest.indexOf(nonHostChars[i]);
        if (index !== -1 &&
            (firstNonHost < 0 || index < firstNonHost)) firstNonHost = index;
      }
  
      if (firstNonHost !== -1) {
        out.host = rest.substr(0, firstNonHost);
        rest = rest.substr(firstNonHost);
      } else {
        out.host = rest;
        rest = '';
      }
  
      // pull out port.
      var p = parseHost(out.host);
      if (out.auth) out.host = out.auth + '@' + out.host;
      var keys = Object.keys(p);
      for (var i = 0, l = keys.length; i < l; i++) {
        var key = keys[i];
        out[key] = p[key];
      }
  
      // we've indicated that there is a hostname,
      // so even if it's empty, it has to be present.
      out.hostname = out.hostname || '';
  
      // validate a little.
      if (out.hostname.length > hostnameMaxLen) {
        out.hostname = '';
      } else {
        var hostparts = out.hostname.split(/\./);
        for (var i = 0, l = hostparts.length; i < l; i++) {
          var part = hostparts[i];
          if (!part) continue;
          if (!part.match(hostnamePartPattern)) {
            var validParts = hostparts.slice(0, i);
            var notHost = hostparts.slice(i + 1);
            var bit = part.match(hostnamePartStart);
            if (bit) {
              validParts.push(bit[1]);
              notHost.unshift(bit[2]);
            }
            if (notHost.length) {
              rest = '/' + notHost.join('.') + rest
            }
            out.hostname = validParts.join('.');
            break;
          }
        }
      }
      // hostnames are always lower case.
      out.hostname = out.hostname.toLowerCase();
  
      out.host = ((out.auth) ? out.auth + '@' : '') +
          (out.hostname || '') +
          ((out.port) ? ':' + out.port : '');
      out.href += out.host;
    }
  
    // now rest is set to the post-host stuff.
    // chop off any delim chars.
    if (!unsafeProtocol[lowerProto]) {
  
      // First, make 100% sure that any "autoEscape" chars get
      // escaped, even if encodeURIComponent doesn't think they
      // need to be.
      for (var i = 0, l = autoEscape.length; i < l; i++) {
        var ae = autoEscape[i];
        var esc = encodeURIComponent(ae);
        if (esc === ae) {
          esc = escape(ae);
        }
        rest = rest.split(ae).join(esc);
      }
  
      // Now make sure that delims never appear in a url.
      var chop = rest.length;
      for (var i = 0, l = delims.length; i < l; i++) {
        var c = rest.indexOf(delims[i]);
        if (c !== -1) {
          chop = Math.min(c, chop);
        }
      }
      rest = rest.substr(0, chop);
    }
  
  
    // chop off from the tail first.
    var hash = rest.indexOf('#');
    if (hash !== -1) {
      // got a fragment string.
      out.hash = rest.substr(hash);
      rest = rest.slice(0, hash);
    }
    var qm = rest.indexOf('?');
    if (qm !== -1) {
      out.search = rest.substr(qm);
      out.query = rest.substr(qm + 1);
      if (parseQueryString) {
        out.query = querystring.parse(out.query);
      }
      rest = rest.slice(0, qm);
    } else if (parseQueryString) {
      // no query string, but parseQueryString still requested
      out.search = '';
      out.query = {};
    }
    if (rest) out.pathname = rest;
    if (slashedProtocol[proto] &&
        out.hostname && !out.pathname) {
      out.pathname = '/';
    }
  
    // finally, reconstruct the href based on what has been validated.
    out.href = urlFormat(out);
  
    return out;
  }
  
  // format a parsed object into a url string
  function urlFormat(obj) {
    // ensure it's an object, and not a string url.
    // If it's an obj, this is a no-op.
    // this way, you can call url_format() on strings
    // to clean up potentially wonky urls.
    if (typeof(obj) === 'string') obj = urlParse(obj);
  
    var auth = obj.auth;
    if (auth) {
      auth = auth.split('@').join('%40');
      for (var i = 0, l = nonAuthChars.length; i < l; i++) {
        var nAC = nonAuthChars[i];
        auth = auth.split(nAC).join(encodeURIComponent(nAC));
      }
    }
  
    var protocol = obj.protocol || '',
        host = (obj.host !== undefined) ? obj.host :
            obj.hostname !== undefined ? (
                (auth ? auth + '@' : '') +
                obj.hostname +
                (obj.port ? ':' + obj.port : '')
            ) :
            false,
        pathname = obj.pathname || '',
        query = obj.query &&
                ((typeof obj.query === 'object' &&
                  Object.keys(obj.query).length) ?
                   querystring.stringify(obj.query) :
                   '') || '',
        search = obj.search || (query && ('?' + query)) || '',
        hash = obj.hash || '';
  
    if (protocol && protocol.substr(-1) !== ':') protocol += ':';
  
    // only the slashedProtocols get the //.  Not mailto:, xmpp:, etc.
    // unless they had them to begin with.
    if (obj.slashes ||
        (!protocol || slashedProtocol[protocol]) && host !== false) {
      host = '//' + (host || '');
      if (pathname && pathname.charAt(0) !== '/') pathname = '/' + pathname;
    } else if (!host) {
      host = '';
    }
  
    if (hash && hash.charAt(0) !== '#') hash = '#' + hash;
    if (search && search.charAt(0) !== '?') search = '?' + search;
  
    return protocol + host + pathname + search + hash;
  }
  
  function urlResolve(source, relative) {
    return urlFormat(urlResolveObject(source, relative));
  }
  
  function urlResolveObject(source, relative) {
    if (!source) return relative;
  
    source = urlParse(urlFormat(source), false, true);
    relative = urlParse(urlFormat(relative), false, true);
  
    // hash is always overridden, no matter what.
    source.hash = relative.hash;
  
    if (relative.href === '') return source;
  
    // hrefs like //foo/bar always cut to the protocol.
    if (relative.slashes && !relative.protocol) {
      relative.protocol = source.protocol;
      return relative;
    }
  
    if (relative.protocol && relative.protocol !== source.protocol) {
      // if it's a known url protocol, then changing
      // the protocol does weird things
      // first, if it's not file:, then we MUST have a host,
      // and if there was a path
      // to begin with, then we MUST have a path.
      // if it is file:, then the host is dropped,
      // because that's known to be hostless.
      // anything else is assumed to be absolute.
  
      if (!slashedProtocol[relative.protocol]) return relative;
  
      source.protocol = relative.protocol;
      if (!relative.host && !hostlessProtocol[relative.protocol]) {
        var relPath = (relative.pathname || '').split('/');
        while (relPath.length && !(relative.host = relPath.shift()));
        if (!relative.host) relative.host = '';
        if (relPath[0] !== '') relPath.unshift('');
        if (relPath.length < 2) relPath.unshift('');
        relative.pathname = relPath.join('/');
      }
      source.pathname = relative.pathname;
      source.search = relative.search;
      source.query = relative.query;
      source.host = relative.host || '';
      delete source.auth;
      delete source.hostname;
      source.port = relative.port;
      return source;
    }
  
    var isSourceAbs = (source.pathname && source.pathname.charAt(0) === '/'),
        isRelAbs = (
            relative.host !== undefined ||
            relative.pathname && relative.pathname.charAt(0) === '/'
        ),
        mustEndAbs = (isRelAbs || isSourceAbs ||
                      (source.host && relative.pathname)),
        removeAllDots = mustEndAbs,
        srcPath = source.pathname && source.pathname.split('/') || [],
        relPath = relative.pathname && relative.pathname.split('/') || [],
        psychotic = source.protocol &&
            !slashedProtocol[source.protocol] &&
            source.host !== undefined;
  
    // if the url is a non-slashed url, then relative
    // links like ../.. should be able
    // to crawl up to the hostname, as well.  This is strange.
    // source.protocol has already been set by now.
    // Later on, put the first path part into the host field.
    if (psychotic) {
  
      delete source.hostname;
      delete source.auth;
      delete source.port;
      if (source.host) {
        if (srcPath[0] === '') srcPath[0] = source.host;
        else srcPath.unshift(source.host);
      }
      delete source.host;
  
      if (relative.protocol) {
        delete relative.hostname;
        delete relative.auth;
        delete relative.port;
        if (relative.host) {
          if (relPath[0] === '') relPath[0] = relative.host;
          else relPath.unshift(relative.host);
        }
        delete relative.host;
      }
      mustEndAbs = mustEndAbs && (relPath[0] === '' || srcPath[0] === '');
    }
  
    if (isRelAbs) {
      // it's absolute.
      source.host = (relative.host || relative.host === '') ?
                        relative.host : source.host;
      source.search = relative.search;
      source.query = relative.query;
      srcPath = relPath;
      // fall through to the dot-handling below.
    } else if (relPath.length) {
      // it's relative
      // throw away the existing file, and take the new path instead.
      if (!srcPath) srcPath = [];
      srcPath.pop();
      srcPath = srcPath.concat(relPath);
      source.search = relative.search;
      source.query = relative.query;
    } else if ('search' in relative) {
      // just pull out the search.
      // like href='?foo'.
      // Put this after the other two cases because it simplifies the booleans
      if (psychotic) {
        source.host = srcPath.shift();
      }
      source.search = relative.search;
      source.query = relative.query;
      return source;
    }
    if (!srcPath.length) {
      // no path at all.  easy.
      // we've already handled the other stuff above.
      delete source.pathname;
      return source;
    }
  
    // if a url ENDs in . or .., then it must get a trailing slash.
    // however, if it ends in anything else non-slashy,
    // then it must NOT get a trailing slash.
    var last = srcPath.slice(-1)[0];
    var hasTrailingSlash = (
        (source.host || relative.host) && (last === '.' || last === '..') ||
        last === '');
  
    // strip single dots, resolve double dots to parent dir
    // if the path tries to go above the root, `up` ends up > 0
    var up = 0;
    for (var i = srcPath.length; i >= 0; i--) {
      last = srcPath[i];
      if (last == '.') {
        srcPath.splice(i, 1);
      } else if (last === '..') {
        srcPath.splice(i, 1);
        up++;
      } else if (up) {
        srcPath.splice(i, 1);
        up--;
      }
    }
  
    // if the path is allowed to go above the root, restore leading ..s
    if (!mustEndAbs && !removeAllDots) {
      for (; up--; up) {
        srcPath.unshift('..');
      }
    }
  
    if (mustEndAbs && srcPath[0] !== '' &&
        (!srcPath[0] || srcPath[0].charAt(0) !== '/')) {
      srcPath.unshift('');
    }
  
    if (hasTrailingSlash && (srcPath.join('/').substr(-1) !== '/')) {
      srcPath.push('');
    }
  
    var isAbsolute = srcPath[0] === '' ||
        (srcPath[0] && srcPath[0].charAt(0) === '/');
  
    // put the host back
    if (psychotic) {
      source.host = isAbsolute ? '' : srcPath.shift();
    }
  
    mustEndAbs = mustEndAbs || (source.host && srcPath.length);
  
    if (mustEndAbs && !isAbsolute) {
      srcPath.unshift('');
    }
  
    source.pathname = srcPath.join('/');
  
  
    return source;
  }
  
  function parseHost(host) {
    var out = {};
    var port = portPattern.exec(host);
    if (port) {
      port = port[0];
      out.port = port.substr(1);
      host = host.substr(0, host.length - port.length);
    }
    if (host) out.hostname = host;
    return out;
  }
  
  }());
  

  provide("url", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*jslint devel: true, debug: true, es5: true, onevar: true, undef: true, nomen: true, eqeqeq: true, plusplus: true, bitwise: true, regexp: true, newcap: true, immed: true, strict: true */
  (function () {
    "use strict";
  
    var globalOptions
      , ahrOptions = exports
      , url = require('url')
      , querystring = require('querystring')
      , File = require('File')
      , FileList = require('FileList')
      , FormData = require('FormData')
      , atob = require('atob')
      , utils = require('ahr.utils')
      , location
      , uriEncodeObject
      , clone
      , preset
      , objectToLowerCase
      ;
  
    try {
      location = require('./location');
    } catch(e) {
      location = require('location');
    }
  
    uriEncodeObject = utils.uriEncodeObject;
    clone = utils.clone;
    preset = utils.preset;
    objectToLowerCase = utils.objectToLowerCase;
  
    globalOptions = {
      ssl: false,
      method: 'GET',
      headers: {
        //'accept': "application/json; charset=utf-8, */*; q=0.5"
      },
      redirectCount: 0,
      redirectCountMax: 5,
      // contentType: 'json',
      // accept: 'json',
      followRedirect: true,
      timeout: 20000
    };
  
  
    //
    // Manage global options while keeping state safe
    //
    ahrOptions.globalOptionKeys = function () {
      return Object.keys(globalOptions);
    };
  
    ahrOptions.globalOption = function (key, val) {
      if ('undefined' === typeof val) {
        return globalOptions[key];
      }
      if (null === val) {
        val = undefined;
      }
      globalOptions[key] = val;
    };
  
    ahrOptions.setGlobalOptions = function (bag) {
      Object.keys(bag).forEach(function (key) {
        globalOptions[key] = bag[key];
      });
    };
  
  
    /*
     * About the HTTP spec and which methods allow bodies, etc:
     * http://stackoverflow.com/questions/299628/is-an-entity-body-allowed-for-an-http-delete-request
     */
    function checkBodyAllowed(options) {
      var method = options.method.toUpperCase();
      if ('HEAD' !== method && 'GET' !== method && 'DELETE' !== method && 'OPTIONS' !== method) {
        return true;
      }
      if (options.body && !options.forceAllowBody) {
        throw new Error("The de facto standard is that '" + method + "' should not have a body.\n" +
          "Most web servers just ignore it. Please use 'query' rather than 'body'.\n" +
          "Also, you may consider filing this as a bug - please give an explanation.\n" +
          "Finally, you may allow this by passing { forceAllowBody: 'true' } ");
      }
      if (options.body && options.jsonp) {
        throw new Error("The de facto standard is that 'jsonp' should not have a body (and I don't see how it could have one anyway).\n" +
          "If you consider filing this as a bug please give an explanation.");
      }
    }
  
  
    /*
      Node.js
  
      > var url = require('url');
      > var urlstring = 'http://user:pass@host.com:8080/p/a/t/h?query=string#hash';
      > url.parse(urlstring, true);
      { href: 'http://user:pass@host.com:8080/p/a/t/h?query=string#hash',
        protocol: 'http:',
        host: 'user:pass@host.com:8080',
        auth: 'user:pass',
        hostname: 'host.com',
        port: '8080',
        pathname: '/p/a/t/h',
        search: '?query=string',
        hash: '#hash',
  
        slashes: true,
        query: {'query':'string'} } // 'query=string'
    */
  
    /*
      Browser
  
        href: "http://user:pass@host.com:8080/p/a/t/h?query=string#hash"
        protocol: "http:" 
        host: "host.com:8080"
        hostname: "host.com"
        port: "8080"
        pathname: "/p/a/t/h"
        search: '?query=string',
        hash: "#hash"
  
        origin: "http://host.com:8080"
     */
  
    function handleUri(options) {
      var presets
        , urlObj
        ;
  
      presets = clone(globalOptions);
  
      if (!options) {
        throw new Error('ARe yOu kiddiNg me? You have to provide some sort of options');
      }
  
      if ('string' === typeof options) {
        options = {
          href: options
        };
      }
      if (options.uri || options.url) {
        console.log('Use `options.href`. `options.url` and `options.uri` are obsolete');
        options.href = options.href || options.url || options.url;
      }
      if (options.params) {
        console.log('Use `options.query`. `options.params` is obsolete');
        options.query = options.query || options.params;
      }
  
  
      //
      // pull `urlObj` from `options`
      //
      if (options.href) {
        urlObj = url.parse(options.href, true, true);
        // ignored anyway
        delete urlObj.href;
        // these trump other options
        delete urlObj.host;
        delete urlObj.search;
      } else {
        urlObj = {
            protocol: options.protocol || location.protocol
        //  host trumps auth, hostname, and port
          , host: options.host
          , auth: options.auth
          , hostname: options.hostname || location.hostname
          , port: options.port || location.port
          , pathname: url.resolve(location.pathname, options.pathname || '') || '/'
        // search trumps query
          , search: options.search
          , query: options.query || querystring.parse(options.search||"")
          , hash: options.hash
        };
      }
      delete options.href;
      delete options.host;
      delete options.auth;
      delete options.host;
      delete options.hostname;
      delete options.pathname;
      delete options.port;
      delete options.path;
      delete options.search;
      delete options.query;
      delete options.hash;
  
      // Use SSL if desired
      if ('https:' === urlObj.protocol || '443' === urlObj.port || true === options.ssl) {
        options.ssl = true;
        urlObj.port = urlObj.port || '443';
        // hopefully no one would set prt 443 to standard http
        urlObj.protocol = 'https:';
      }
  
      if ('tcp:' === urlObj.protocol || 'tcps:' === urlObj.protocol || 'udp:' === urlObj.protocol) {
        options.method = options.method || 'POST';
      }
  
      if (!options.method && (options.body || options.encodedBody)) {
        options.method = 'POST';
      }
  
      if (options.jsonp) {
        // i.e. /path/to/res?x=y&jsoncallback=jsonp8765
        // i.e. /path/to/res?x=y&json=jsonp_ae75f
        options.jsonpCallback = 'jsonp_' + (new Date()).valueOf();
        options.dataType = 'jsonp';
        urlObj.query[options.jsonp] = options.jsonpCallback;
      }
  
      // for the sake of the browser, but it doesn't hurt node
      if (!urlObj.auth && options.username && options.password) {
        urlObj.auth = options.username + ':' + options.password;
      } else if (urlObj.auth) {
        urlObj.username = urlObj.auth.split(':')[0];
        urlObj.password = urlObj.auth.split(':')[1];
      }
  
      urlObj.href = url.format(urlObj);
      urlObj = url.parse(urlObj.href, true, true);
  
      preset(options, presets);
      preset(options, urlObj);
      options.syncback = options.syncback || function () {};
  
      return options;
    }
  
    function handleHeaders(options) {
      var presets
        ;
  
      presets = clone(globalOptions);
  
      options.headers = options.headers || {};
      if (options.jsonp) {
        options.headers.accept = "text/javascript";
      }
      // TODO user-agent should retain case
      options.headers = objectToLowerCase(options.headers || {});
      options.headers = preset(options.headers, presets.headers);
      // TODO port?
      options.headers.host = options.hostname;
      options.headers = objectToLowerCase(options.headers);
      if (options.contentType) {
        options.headers['content-type'] = options.contentType;
      }
  
      // for the sake of node, but it doesn't hurt the browser
      if (options.auth) {
        options.headers.authorization = 'Basic ' + atob(options.auth);
      }
  
      return options;
    }
  
    function hasFiles(body, formData) {
      var hasFile = false;
      if ('object' !== typeof body) {
        return false;
      }
      Object.keys(body).forEach(function (key) {
        var item = body[key];
        if (item instanceof File) {
          hasFile = true;
        } else if (item instanceof FileList) {
          hasFile = true;
        }
      });
      return hasFile;
    }
    function addFiles(body, formData) {
  
      Object.keys(body).forEach(function (key) {
        var item = body[key];
  
        if (item instanceof File) {
          formData.append(key, item);
        } else if (item instanceof FileList) {
          item.forEach(function (file) {
            formData.append(key, file);
          });
        } else {
          formData.append(key, item);
        }
      });
    }
  
    // TODO convert object/map body into array body
    // { "a": 1, "b": 2 } --> [ "name": "a", "value": 1, "name": "b", "value": 2 ]
    // this would be more appropriate and in better accordance with the http spec
    // as it allows for a value such as "a" to have multiple values rather than
    // having to do "a1", "a2" etc
    function handleBody(options) {
      function bodyEncoder() {
        checkBodyAllowed(options);
  
        if (options.encodedBody) {
          return;
        }
  
        //
        // Check for HTML5 FileApi files
        //
        if (hasFiles(options.body)) {
          options.encodedBody = new FormData(); 
          addFiles(options.body, options.encodedBody);
        }
        if (options.body instanceof FormData) {
          options.encodedBody = options.body;
        }
        if (options.encodedBody instanceof FormData) {
            // TODO: is this necessary? This breaks in the browser
  //        options.headers["content-type"] = "multipart/form-data";
          return;
        }
  
        if ('string' === typeof options.body) {
          options.encodedBody = options.body;
        }
  
        if (!options.headers["content-type"]) {
          //options.headers["content-type"] = "application/x-www-form-urlencoded";
          options.headers["content-type"] = "application/json";
        }
  
        if (!options.encodedBody) {
          if (options.headers["content-type"].match(/application\/json/) || 
              options.headers["content-type"].match(/text\/javascript/)) {
            options.encodedBody = JSON.stringify(options.body);
          } else if (options.headers["content-type"].match(/application\/x-www-form-urlencoded/)) {
              options.encodedBody = uriEncodeObject(options.body);
          }
  
          if (!options.encodedBody) {
            throw new Error("'" + options.headers["content-type"] + "'" + "is not yet supported and you have not specified 'encodedBody'");
          }
  
          options.headers["content-length"] = options.encodedBody.length;
        }
      }
  
      function removeContentBodyAndHeaders() {
        if (options.body) {
          throw new Error('You gave a body for one of HEAD, GET, DELETE, or OPTIONS');
        }
  
        options.encodedBody = "";
        delete options.headers["content-type"];
        delete options.headers["content-length"];
        delete options.headers["transfer-encoding"];
      }
  
      if ('file:' === options.protocol) {
        delete options.header;
        return;
      }
  
      // Create & Send body
      // TODO support streaming uploads
      delete options.headers["transfer-encoding"];
  
      if (options.body || options.encodedBody) {
        bodyEncoder(options);
      } else { // no body || body not allowed
        removeContentBodyAndHeaders(options);
      }
    }
  
    ahrOptions.handleOptions = function (options) {
      handleUri(options);
      handleHeaders(options);
      handleBody(options);
  
      return options;
    };
  }());
  

  provide("ahr.options", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*
     loadstart;
     progress;
     abort;
     error;
     load;
     timeout;
     loadend;
  */
  (function () {
    "use strict";
  
    function browserJsonpClient(req, res) {
      // TODO check for Same-domain / XHR2/CORS support
      // before attempting to insert script tag
      // Those support headers and such, which are good
      var options = req.userOptions
        , cbkey = options.jsonpCallback
        , script = document.createElement("script")
        , head = document.getElementsByTagName("head")[0] || document.documentElement
        , addParamsToUri = require('ahr.utils').addParamsToUri
        , timeout
        , fulfilled; // TODO move this logic elsewhere into the emitter
  
      // cleanup: cleanup window and dom
      function cleanup() {
        fulfilled = true;
        window[cbkey] = undefined;
        try {
          delete window[cbkey];
          // may have already been removed
          head.removeChild(script);
        } catch(e) {}
      }
  
      function abortRequest() {
        req.emit('abort');
        cleanup();
      }
  
      function abortResponse() {
        res.emit('abort');
        cleanup();
      }
  
      function prepareResponse() {
        // Sanatize data, Send, Cleanup
        function onSuccess(data) {
          var ev = {
            lengthComputable: false,
            loaded: 1,
            total: 1
          };
          if (fulfilled) {
            return;
          }
  
          clearTimeout(timeout);
          res.emit('loadstart', ev);
          // sanitize
          data = JSON.parse(JSON.stringify(data));
          res.emit('progress', ev);
          ev.target = { result: data };
          res.emit('load', ev);
          cleanup();
        }
  
        function onTimeout() {
          res.emit('timeout', {});
          res.emit('error', new Error('timeout'));
          cleanup();
        }
  
        window[cbkey] = onSuccess;
        // onError: Set timeout if script tag fails to load
        if (options.timeout) {
          timeout = setTimeout(onTimeout, options.timeout);
        }
      }
  
      function makeRequest() {
        var ev = {}
          , jsonp = {};
  
        function onError(ev) {
          res.emit('error', ev);
        }
  
        // ?search=kittens&jsonp=jsonp123456
        jsonp[options.jsonp] = options.jsonpCallback;
        options.href = addParamsToUri(options.href, jsonp);
  
        // Insert JSONP script into the DOM
        // set script source to the service that responds with thepadded JSON data
        req.emit('loadstart', ev);
        try {
          script.setAttribute("type", "text/javascript");
          script.setAttribute("async", "async");
          script.setAttribute("src", options.href);
          // Note that this only works in some browsers,
          // but it's better than nothing
          script.onerror = onError;
          head.insertBefore(script, head.firstChild);
        } catch(e) {
          req.emit('error', e);
        }
  
        // failsafe cleanup
        setTimeout(cleanup, 2 * 60 * 1000);
        // a moot point since the "load" occurs so quickly
        req.emit('progress', ev);
        req.emit('load', ev);
      }
  
      setTimeout(makeRequest, 0);
      req.abort = abortRequest;
      res.abort = abortResponse;
      prepareResponse();
  
      return res;
    }
  
    module.exports = browserJsonpClient;
  }());
  

  provide("ahr.browser.jsonp", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*jslint devel: true, debug: true, es5: true, onevar: true, undef: true, nomen: true, eqeqeq: true, plusplus: true, bitwise: true, regexp: true, newcap: true, immed: true, strict: true */
  // This module is meant for modern browsers. Not much abstraction or 1337 majic
  (function (undefined) {
    "use strict";
  
    var url //= require('url')
      , browserJsonpClient = require('ahr.browser.jsonp')
      , triedHeaders = {}
      , nativeHttpClient
      , globalOptions
      , restricted
      , debug = false
      ; // TODO underExtend localOptions
  
    // Restricted Headers
    // http://www.w3.org/TR/XMLHttpRequest/#the-setrequestheader-method
    restricted = [
        "Accept-Charset"
      , "Accept-Encoding"
      , "Connection"
      , "Content-Length"
      , "Cookie"
      , "Cookie2"
      , "Content-Transfer-Encoding"
      , "Date"
      , "Expect"
      , "Host"
      , "Keep-Alive"
      , "Referer"
      , "TE"
      , "Trailer"
      , "Transfer-Encoding"
      , "Upgrade"
      , "User-Agent"
      , "Via"
    ];
    restricted.forEach(function (val, i, arr) {
      arr[i] = val.toLowerCase();
    });
  
    if (!window.XMLHttpRequest) {
      window.XMLHttpRequest = function() {
        return new ActiveXObject('Microsoft.XMLHTTP');
      };
    }
    if (window.XDomainRequest) {
      // TODO fix IE's XHR/XDR to act as normal XHR2
      // check if the location.host is the same (name, port, not protocol) as origin
    }
  
  
    function encodeData(options, xhr2) {
      var data
        , ct = options.overrideResponseType || xhr2.getResponseHeader("content-type") || ""
        , text
        , len
        ;
  
      ct = ct.toLowerCase();
  
      if (xhr2.responseType && xhr2.response) {
        text = xhr2.response;
      } else {
        text = xhr2.responseText;
      }
  
      len = text.length;
  
      if ('binary' === ct) {
        if (window.ArrayBuffer && xhr2.response instanceof window.ArrayBuffer) {
          return xhr2.response;
        }
  
        // TODO how to wrap this for the browser and Node??
        if (options.responseEncoder) {
          return options.responseEncoder(text);
        }
  
        // TODO only Chrome 13 currently handles ArrayBuffers well
        // imageData could work too
        // http://synth.bitsnbites.eu/
        // http://synth.bitsnbites.eu/play.html
        // var ui8a = new Uint8Array(data, 0);
        var i
          , ui8a = Array(len)
          ;
  
        for (i = 0; i < text.length; i += 1) {
          ui8a[i] = (text.charCodeAt(i) & 0xff);
        }
  
        return ui8a;
      }
  
      if (ct.indexOf("xml") >= 0) {
        return xhr2.responseXML;
      }
  
      if (ct.indexOf("jsonp") >= 0 || ct.indexOf("javascript") >= 0) {
        console.log("forcing of jsonp not yet supported");
        return text;
      }
  
      if (ct.indexOf("json") >= 0) {
        try {
          data = JSON.parse(text);
        } catch(e) {
          data = text;
        }
        return data;
      }
  
      return xhr2.responseText;
    }
  
    function browserHttpClient(req, res) {
      var options = req.userOptions
        , xhr2
        , xhr2Request
        , timeoutToken
        ;
  
      function onTimeout() {
        req.emit("timeout", new Error("timeout after " + options.timeout + "ms"));
      }
  
      function resetTimeout() {
        clearTimeout(timeoutToken);
        timeoutToken = setTimeout(onTimeout, options.timeout);
      }
  
      function sanatizeHeaders(header) {
        var value = options.headers[header]
          , headerLc = header.toLowerCase()
          ;
  
        // only warn the user once about bad headers
        if (-1 !== restricted.indexOf(header.toLowerCase())) {
          if (!triedHeaders[headerLc]) {
            console.error('Ignoring all attempts to set restricted header ' + header + '. See (http://www.w3.org/TR/XMLHttpRequest/#the-setrequestheader-method)');
          }
          triedHeaders[headerLc] = true;
          return;
        }
  
        try {
          // throws INVALID_STATE_ERROR if called before `open()`
          xhr2.setRequestHeader(header, value);
        } catch(e) {
          console.error('error setting header: ' + header);
          console.error(e);
        }
      }
  
      // A little confusing that the request object gives you
      // the response handlers and that the upload gives you
      // the request handlers, but oh well
      xhr2 = new XMLHttpRequest();
      xhr2Request = xhr2.upload;
  
      /* Proper States */
      xhr2.addEventListener('loadstart', function (ev) {
          // this fires when the request starts,
          // but shouldn't fire until the request has loaded
          // and the response starts
          req.emit('loadstart', ev);
          resetTimeout();
      }, true);
      xhr2.addEventListener('progress', function (ev) {
          if (!req.loaded) {
            req.loaded = true;
            req.emit('progress', {});
            req.emit('load', {});
          }
          if (!res.loadstart) {
            res.headers = xhr2.getAllResponseHeaders();
            res.loadstart = true;
            res.emit('loadstart', ev);
          }
          res.emit('progress', ev);
          resetTimeout();
      }, true);
      xhr2.addEventListener('load', function (ev) {
        if (xhr2.status >= 400) {
          ev.error = new Error(xhr2.status);
        }
        ev.target.result = encodeData(options, xhr2);
        res.emit('load', ev);
      }, true);
      /*
      xhr2Request.addEventListener('loadstart', function (ev) {
        req.emit('loadstart', ev);
        resetTimeout();
      }, true);
      */
      xhr2Request.addEventListener('load', function (ev) {
        resetTimeout();
        req.loaded = true;
        req.emit('load', ev);
        res.loadstart = true;
        res.emit('loadstart', {});
      }, true);
      xhr2Request.addEventListener('progress', function (ev) {
        resetTimeout();
        req.emit('progress', ev);
      }, true);
  
  
      /* Error States */
      xhr2.addEventListener('abort', function (ev) {
        res.emit('abort', ev);
      }, true);
      xhr2Request.addEventListener('abort', function (ev) {
        req.emit('abort', ev);
      }, true);
      xhr2.addEventListener('error', function (ev) {
        res.emit('error', ev);
      }, true);
      xhr2Request.addEventListener('error', function (ev) {
        req.emit('error', ev);
      }, true);
      // the "Request" is what timeouts
      // the "Response" will timeout as well
      xhr2.addEventListener('timeout', function (ev) {
        req.emit('timeout', ev);
      }, true);
      xhr2Request.addEventListener('timeout', function (ev) {
        req.emit('timeout', ev);
      }, true);
  
      /* Cleanup */
      res.on('loadend', function () {
        // loadend is managed by AHR
        req.status = xhr2.status;
        res.status = xhr2.status;
        clearTimeout(timeoutToken);
      });
  
      if (options.username) {
        xhr2.open(options.method, options.href, true, options.username, options.password);
      } else {
        xhr2.open(options.method, options.href, true);
      }
  
      Object.keys(options.headers).forEach(sanatizeHeaders);
  
      setTimeout(function () {
        if ('binary' === options.overrideResponseType) {
          xhr2.overrideMimeType("text/plain; charset=x-user-defined");
          xhr2.responseType = 'arraybuffer';
        }
        try {
          xhr2.send(options.encodedBody);
        } catch(e) {
          req.emit('error', e);
        }
      }, 1);
      
  
      req.abort = function () {
        xhr2.abort();
      };
      res.abort = function () {
        xhr2.abort();
      };
  
      res.browserRequest = xhr2;
      return res;
    }
  
    function send(req, res) {
      var options = req.userOptions;
      // TODO fix this ugly hack
      url = url || require('url');
      if (options.jsonp && options.jsonpCallback) {
        return browserJsonpClient(req, res);
      }
      return browserHttpClient(req, res);
    }
  
    module.exports = send;
  }());
  

  provide("ahr.browser.request", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  // intentionally blank
  

  provide("ahr.browser", module.exports);

  $.ender(module.exports);

}();

!function () {

  var module = { exports: {} }, exports = module.exports;

  /*jslint devel: true, debug: true, es5: true, onevar: true, undef: true, nomen: true, eqeqeq: true, plusplus: true, bitwise: true, regexp: true, newcap: true, immed: true, strict: true */
  (function () {
    "use strict";
  
    var EventEmitter = require('events.node').EventEmitter
      , Future = require('future')
      , Join = require('join')
      , ahrOptions
      , nextTick
      , utils
      , preset
      ;
  
    function nextTick(fn, a, b, c, d) {
      try {
        process.nextTick(fn, a, b, c, d);
      } catch(e) {
        setTimeout(fn, 0, a, b, c, d);
      }
    }
  
    ahrOptions = require('ahr.options');
    utils = require('ahr.utils');
    
    preset = utils.preset;
  
    // The normalization starts here!
    function NewEmitter() {
      var emitter = new EventEmitter()
        , promise = Future()
        , ev = {
              lengthComputable: false
            , loaded: 0
            , total: undefined
          };
  
      function loadend(ev, errmsg) {
        nextTick(function () {
          ev.error = errmsg && new Error(errmsg);
          emitter.emit('loadend', ev);
        });
      }
  
      // any error in the quest causes the response also to fail
      emitter.on('loadend', function (ev) {
        if (emitter.done) {
          console.error('loadend called several times', emitter, ev);
        }
        emitter.done = true;
        // in FF this is only a getter, setting is not allowed
        if (!ev.target) {
          ev.target = {};
        }
        promise.fulfill(emitter.error || ev.error, emitter, ev.target.result, ev.error ? false : true);
      });
      emitter.on('timeout', function (ev) {
        emitter.error = ev;
        loadend(ev, 'timeout');
      });
      emitter.on('abort', function (ev) {
        loadend(ev, 'abort');
      });
      emitter.on('error', function (err, evn) {
        // TODO rethrow the error if there are no listeners (incl. promises)
        //if (respEmitter.listeners.loadend) {}
        if (emitter.cancelled) {
          // return;
        }
        emitter.error = err;
        ev.error = err;
        if (evn) {
          ev.lengthComputable = evn.lengthComputable || true;
          ev.loaded = evn.loaded || 0;
          ev.total = evn.total;
        }
        loadend(ev);
      });
      // TODO there can actually be multiple load events per request
      // as is the case with mjpeg, streaming media, and ad-hoc socket-ish things
      emitter.on('load', function (evn) {
        // ensure that `loadend` is after `load` for all interested parties
        if (emitter.cancelled) {
          return;
        }
        loadend(evn);
      });
  
      // TODO 3.0 remove when
      emitter.when = promise.when;
  
      return emitter;
    }
  
  
    //
    // Emulate `request`
    //
    function ahr(options, callback) {
      var NativeHttpClient
        , req = NewEmitter()
        , res = NewEmitter()
        ;
  
      if (callback || options.callback) {
        // TODO 3.0 remove when
        return ahr(options).when(callback);
      }
  
      if ('string' === typeof options) {
        options = {
          href: options
        };
      }
  
      ahrOptions.handleOptions(options);
  
      // todo throw all the important properties in the request
      req.userOptions = options;
      // in the browser tradition
      res.upload = req;
  
      // if the request fails, then the response must also fail
      req.on('error', function (err, ev) {
        if (!res.error) {
          res.emit('error', err, ev);
        }
      });
      req.on('timeout', function (ev) {
        if (!res.error) {
          res.emit('timeout', ev);
        }
      });
      req.on('abort', function (ev) {
        if (!res.error) {
          res.emit('abort', ev);
        }
      });
  
      try {
        NativeHttpClient = require('ahr.node');
      } catch(e) {
        NativeHttpClient = require('ahr.browser.request');
      }
  
      return NativeHttpClient(req, res);
    };
    ahr.globalOptionKeys = ahrOptions.globalOptionKeys;
    ahr.globalOption = ahrOptions.globalOption;
    ahr.setGlobalOptions = ahrOptions.setGlobalOptions;
    ahr.handleOptions = ahrOptions.handleOptions;
  
  
    // TODO 3.0 remove join
    ahr.join = Join;
  
  
    //
    //
    // All of these convenience methods are safe to cut if needed to save kb
    //
    //
    function allRequests(method, href, query, body, jsonp, options, callback) {
      options = options || {};
  
      if (method) { options.method = method; }
      if (href) { options.href = href; }
      if (jsonp) { options.jsonp = jsonp; }
  
      if (query) { options.query = preset((query || {}), (options.query || {})) }
      if (body) { options.body = body; }
  
      return ahr(options, callback);
    }
  
    ahr.http = ahr;
    ahr.file = ahr;
    // TODO copy the jquery / reqwest object syntax
    // ahr.ajax = ahr;
  
    // HTTP jQuery-like body-less methods
    ['HEAD', 'GET', 'DELETE', 'OPTIONS'].forEach(function (verb) {
      verb = verb.toLowerCase();
      ahr[verb] = function (href, query, options, callback) {
        return allRequests(verb, href, query, undefined, undefined, options, callback);
      };
    });
  
    // Correcting an oversight of jQuery.
    // POST and PUT can have both query (in the URL) and data (in the body)
    ['POST', 'PUT'].forEach(function (verb) {
      verb = verb.toLowerCase();
      ahr[verb] = function (href, query, body, options, callback) {
        return allRequests(verb, href, query, body, undefined, options, callback);
      };
    });
  
    // JSONP
    ahr.jsonp = function (href, jsonp, query, options, callback) {
      if (!jsonp || 'string' !== typeof jsonp) {
        throw new Error("'jsonp' is not an optional parameter.\n" +
          "If you believe that this should default to 'callback' rather" +
          "than throwing an error, please file a bug");
      }
  
      return allRequests('GET', href, query, undefined, jsonp, options, callback);
    };
  
    // HTTPS
    ahr.https = function (options, callback) {
      if ('string' === typeof options) {
        options = {
          href: options
        };
      }
  
      options.ssl = true;
      options.protocol = "https:";
  
      return ahr(options, callback);
    };
  
    ahr.tcp = function (options, callback) {
      if ('string' === typeof options) {
        options = {
          href: options
        };
      }
  
      options.protocol = "tcp:";
  
      return ahr(options, callback);
    };
  
    ahr.udp = function (options, callback) {
      if ('string' === typeof options) {
        options = {
          href: options
        };
      }
  
      options.protocol = "udp:";
  
      return ahr(options, callback);
    };
  
    module.exports = ahr;
  }());
  

  provide("ahr2", module.exports);

  $.ender(module.exports);

}();